#!/usr/bin/perl
################################################################################
#
# This Perl program COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program, or any code segments from it, for any
# purpose, personal or commercial, is expressly forbidden except by express
# written permission of Paul Galloway.
#
# You may contact the author at the following address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

$cgiscript = "install.cgi";
$|++;
&get_input; #if just starting, enter data in form
if ($mode eq 'confirm')
{
	&check_input; #Data entered, now check it and get confirmation
}
else { &execute; } #Entered, checked, and confirmed
exit;

sub get_input
{
	if ($ENV{'REQUEST_METHOD'} eq "GET")
	{
		$buffer=$ENV{'QUERY_STRING'};
	}
	else 
	{
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) 
	{
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/<!--(.|\n)*-->//g;
		$value =~ s/\|/ /g;
		$FORM{$name} = $value;
	}
	
	foreach $key (keys %FORM)
	{
		$FORM{$key} =~ tr/\&\;\`\'\\\"\|\*\?\<\>\^\(\)\[\]\{\}\$\n\r/                     /;
	}

	$mode = $FORM{'mode'};
	if ($FORM{'mode'} eq "") 
	{
		&output_form;
		exit;
	}

	$dealer_self_modify = $FORM{'dealer_self_modify'};
	$gradtype1 = $FORM{'gradtype1'};
	$gradtype2 = $FORM{'gradtype2'};
	$gradtype3 = $FORM{'gradtype3'};
	$gradtype3 = $FORM{'gradtype4'};

	$sgradtype1 = $FORM{'sgradtype1'};
	$sgradtype2 = $FORM{'sgradtype2'};
	$sgradtype3 = $FORM{'sgradtype3'};
	$sgradtype3 = $FORM{'sgradtype4'};
	
	$cgiurlguess = $FORM{'cgiurlguess'};
	$cgiurlguess =~ s/\/$//;
	
	$cgibinguess = $FORM{'cgibinguess'};
	$cgibinguess =~ s/\/$//;
	
	$mailprog=$FORM{'mailprog'};
	$mailprog2=$FORM{'mailprog2'};
	
	$tempdir=$FORM{'tempdir'};
	$tempdir =~ s/\/$//;
	
	$admindir=$FORM{'admindir'};
	$admindir =~ s/\/$//;
	
	$assocdir=$FORM{'assocdir'};
	$assocdir =~ s/\/$//;
	
	$fileprefix=$FORM{'fileprefix'};
	$anumprefix=$FORM{'anumprefix'};
	$anumsuffix=$FORM{'anumsuffix'};
	$initialanum=$FORM{'initialanum'};
	$baseurl1=$FORM{'baseurl1'};
	$baseurl2=$FORM{'baseurl2'};
	$baseurl=$FORM{'baseurl'};
	$anotifydealer=$FORM{'anotifydealer'};
	$anotify=$FORM{'anotify'};
	$store_card=$FORM{'store_card'};
	$email_card=$FORM{'email_card'};
	$taxshipping=$FORM{'taxshipping'};
	$security=$FORM{'security'};
	$log_hits=$FORM{'log_hits'};
	$pages_to_log=$FORM{'pages_to_log'};
	$num_refer=$FORM{'num_refer'};
	$log_method=$FORM{'log_method'};
	$allow_self_modify=$FORM{'allow_self_modify'};
	$auto_sponsor_notify=$FORM{'auto_sponsor_notify'};
	$mlm=$FORM{'mlm'};
	$admin_email=$FORM{'admin_email'};
	$admin_name=$FORM{'admin_name'};
	$password=$FORM{'password'};
	
}


sub check_input
{
	$required = "mailprog-Mail Program (Sendmail) Path Missing,tempdir-Template Directory Path Missing,admindir-Admin Directory Path Missing,baseurl-Base URL Data Missing,admin_email-Admin Email Address Missing,admin_name-Admin Name Missing,password-Password Missing"; 
	if ($FORM{'make_static_capable'} eq "yes")
	{
		$required .= ",assocdir-Affiliate Directory Path Missing";
	}
	
	if ($mailprog2 ne "") {$mailprog=$mailprog2; $FORM{'mailprog'} = $FORM{'mailprog2'}; }

	@required = split(/,/, $required);
	foreach $var (@required)
	{
		($fieldname, $message) = split(/-/, $var);
		if ($FORM{$fieldname} eq "")
		{
			push (@errors, "$message");
			$error = "true";
		}
	}

	$errordir = $admindir;
	$errordir =~ s/admin/errors/;
	push (@directories, $tempdir);
	push (@directories, $admindir);
	push (@directories, $errordir);
	push (@directories, "$admindir/ip");
	push (@directories, "$admindir/cookie_IP");
	push (@directories, "$admindir/access_logs");
	push (@directories, "$admindir/aff_info");
	push (@directories, "$admindir/aff_points");
	push (@directories, "$admindir/aff_orders");
	push (@directories, "$admindir/temp");
	if ($FORM{'make_static_capable'} eq "yes")
	{
		push (@directories, $assocdir);
	}
	#push (@directories, "optstart.txt");
	if ($mailprog2 eq "") 
	{
		push (@directories, $mailprog); 
	}
	else 
	{ 
		push (@directories, $mailprog2);
		$FORM{'mailprog'} = $mailprog2;
	}
	foreach $directory (@directories)
	{
		if (! -e $directory) 
		{
			$error = "true";
			push(@errors, "Cannot find $directory");
		}
	}
	if ($error ne "true")
	{
		while ($directory = shift(@directories))
		{
			$directory = shift(@directories);
			if (! -w $directory && -d $directory)
			{
				$error="true";
				push (@errors, "$directory is not writeable -- please change its file permissions . . .");
			}
		}
	}
	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Software Installation -- Confirm</TITLE></HEAD>";
	print "<BODY BGCOLOR=\"\#FFFFFF\" TEXT=\"\#000000\" LINK=\"\#0000FF\" VLINK=\"\#000000\" ALINK=\"\#000000\">";
	print "<CENTER><B><FONT COLOR=\"FF0000\">Software Installation -- Confirm</FONT></B></CENTER><P>";
	if ($error eq "true")
	{ 
		print "<CENTER><FONT COLOR=\"FF0000\" SIZE=5>An Error Was Found . . .</FONT></CENTER><P>";
		print "The following errors were found. Please hit the \"BACK\" button on your browser and make sure you have filled in all required fields before submitting the form.<P>If there are errors from filenames or directories that could not be found, please create the directories/files in question or change the path/name values before resubmitting the form.<P>";
		foreach $var(@errors)
		{
			print "$var<BR>";
		}
		print "</BODY></HTML>";
		exit;
	}
	print "Congratulations, it appears that you filled out the form correctly! Also, all the directory and file paths you listed have been confirmed (they DO exist)!<P>Click on the \"Install!\" button to create your options.pm file (the full pathname of the created file will be $admindir/options.pm )";
	print "<FORM ACTION=\"$cgiscript\" METHOD=\"POST\">";
	print "<INPUT TYPE=\"submit\" VALUE=\"Install!\">";
	print "<HR>(For troubleshooting purposes, here is a list of the FORM variables and their values. Please copy/paste this information into any emails you send me, along with an explanation of the trouble you're having.)<HR>";
	foreach $var (keys(%FORM))
	{
		print "$var = $FORM{$var}<BR>\n";
		print "<INPUT TYPE=\"hidden\" NAME=\"$var\" VALUE=\"$FORM{$var}\">\n";
	}
	print "<INPUT TYPE=\"hidden\" NAME=\"mode\" VALUE=\"execute\">";
	print "</FORM>";
	print "</BODY></HTML>";
}


sub execute
{
	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Creating \"options.pm\" file . . . </TITLE></HEAD>";
	print "<BODY BGCOLOR=\"\#FFFFFF\" TEXT=\"\#000000\" LINK=\"\#0000FF\" VLINK=\"\#000000\" ALINK=\"\#000000\">";
	print "<BLOCKQUOTE><CENTER><FONT SIZE=5 COLOR=\"FF0000\">Creating \"options.pm\" file . . .</FONT></CENTER><P>";
	#open(STARTER, "<optstart.txt");
	open(OPTIONS, ">$admindir/options.pm");
	while(<DATA>)
	{
		print OPTIONS;
	}
	close(OPTIONS);
	#close(STARTER);
	
	$admin_email =~ s/\@/\\\@/;
	$anotify =~ s/YES/1/;
	$anotify =~ s/NO/0/;
	$anotifydealer =~ s/YES/1/;
	$anotifydealer =~ s/NO/0/;
	$dealer_self_modify =~ s/YES/1/;
	$dealer_self_modify =~ s/NO/0/;
	$email_card =~ s/YES/1/;
	$store_card =~ s/NO/0/;
	$store_card =~ s/YES/1/;
	$taxshipping =~ s/NO/0/;
	$taxshipping =~ s/YES/1/;
	$mlm =~ s/NO/0/;
	$mlm =~ s/YES/1/;
	$allow_self_modify =~ s/NO/0/;
	$allow_self_modify =~ s/YES/1/;
	$auto_sponsor_notify =~ s/NO/0/;
	$auto_sponsor_notify =~ s/YES/1/;
	$assocdir ||= "/notapplicable-change-for-later-use";
	@temp = split (/\//, $assocdir);
	$last = $#temp;
	$endpath=$temp[$last];
	chop $endpath if ($endpath =~ /\n$/);
	if ($log_hits eq "No") { $log_hits = 0; }
	else 
	{ 
		$log_hits = 1;
	}
	open (OPTIONS, ">>$admindir/options.pm");
	print OPTIONS "\#  *** DIRECTORY PATHS  ***\n\n";
	print OPTIONS "\$originals_dir=\"$tempdir\"\;\n";
	print OPTIONS "\$clone_dir=\"$assocdir/AFF_NUM\"\;\n";
	print OPTIONS "\$clone_root=\"$assocdir\"\;\n";
	print OPTIONS "\$log_dir=\"$admindir\"\;\n";
 	print OPTIONS "\$dealer_dbfile_dir=\"\$log_dir/db_files\"\;\n"; #NEW
 	print OPTIONS "\$lock_dir=\"\$log_dir/lock\"\;\n"; #NEW
 	print OPTIONS "\$nfo_dir=\"\$log_dir/aff_info\"\;\n";
 	print OPTIONS "\$points_dir=\"\$log_dir/aff_points\"\;\n"; #NEW
	print OPTIONS "\$ord_dir=\"\$log_dir/aff_orders\"\;\n";
	print OPTIONS "\$temp_dir=\"\$log_dir/temp\"\;\n";
	print OPTIONS "\$ip_dir=\"\$log_dir/ip\"\;\n";
	
	print OPTIONS "\$access_log_dir = \"\$log_dir/access_logs\"; \#daily traffic log files kept here\n"; #NEW
	print OPTIONS "\$iptrack_dir = \"\$log_dir/cookie_IP\"; \#Used by IP - Affnum cross-referencing routine\n\n"; #NEW

	print OPTIONS "\n\n\# *** FILE PATHS *** \n";
	print OPTIONS "\$success_message=\"\$log_dir/signup_email.txt\"\;\n";
	print OPTIONS "\$regthankyou=\"\$log_dir/signup_thankyou.html\"\;\n";  
	print OPTIONS "\$orderemail=\"\$log_dir/order_email.txt\"\;\n";
	print OPTIONS "\$customers_email_list=\"\$log_dir/customers.txt\"\;\n";
	print OPTIONS "\$dealers_email_list=\"\$log_dir/dealers.txt\"\;\n";
	
	print OPTIONS "\$dealer_dbfile=\"\$log_dir/db_files/affiliateurls\"\;\n"; #NEW
	
	print OPTIONS "\$thankyoupage = \"\$log_dir/order_thanks.html\"; \#used by proc_ord.cgi (no real-time credit card processing)\n"; #NEW
	print OPTIONS "\$ordersummary = \"\$log_dir/order_summary.txt\"; \#used only with added real-time credit card processing module\n"; #NEW
	print OPTIONS "\$accept_file = \"\$log_dir/accept.html\"; \#used only with AuthorizeNet real-time credit card processing module\n"; #NEW
	print OPTIONS "\$deny_file = \"\$log_dir/deny.html\"; \#used only with AuthorizeNet real-time credit card processing module\n\n"; #NEW
	print OPTIONS "\#for SecureTrans, accept.html and deny.html should be located in a web-accessible area\n";
	print OPTIONS "\#The accept/deny files used with AuthorizeNet won't work with SecureTrans\n";
	

	print OPTIONS "\n\n\# *** MAIL PROGRAM PATH ***\n";
	print OPTIONS "\$mailprog=\"$mailprog\"\;\n";
	print OPTIONS "\$next_aff_num=\"\$log_dir/nextnum.txt\"\;\n\n";
	
	print OPTIONS "\n\n\# *** URL PATHS ***\n";
	print OPTIONS "\$clone_url=\"$baseurl/$endpath/AFF_NUM\"\;\n";
	print OPTIONS "\$cgi_url=\"$cgiurlguess\"\;\n";
	print OPTIONS "\$images_url=\"$baseurl/yimages\"; \#used for program graphics\n\n"; #NEW
	print OPTIONS "\$header_image_url=\"$FORM{'header_image_url'}\";\n\n"; #NEW
	print OPTIONS "\$header_image_width=\"$FORM{'header_image_width'}\";\n\n"; #NEW
	print OPTIONS "\$header_image_height=\"$FORM{'header_image_height'}\";\n\n"; #NEW

	print OPTIONS "\n\n\# *** GENERAL CONFIGURATION VARIABLES ***\n";
	print OPTIONS "\$aff_num_prefix=\"$anumprefix\";\n";
	print OPTIONS "\$aff_num_suffix=\"$anumsuffix\";\n";
	print OPTIONS "\$file_prefix=\"adm\";\n";
	print OPTIONS "\$initial_aff_number=$initialanum;\n";
	print OPTIONS "\$admin_name=\"$admin_name\";\n";
	print OPTIONS "\$admin_email=\"$admin_email\";\n";
	print OPTIONS "\$auto_dealer_notify=$anotifydealer;\n";
	print OPTIONS "\$auto_notify=$anotify;\n";
	print OPTIONS "\$store_card=1;\n";
	print OPTIONS "\$email_card=0;\n";
	print OPTIONS "\$taxshipping=0;\n";
	print OPTIONS "\$log_hits=$log_hits;\n";
	print OPTIONS "\$point_system=\"$FORM{'enable_point_system'}\";\n"; #NEW
	print OPTIONS "\$make_static_capable=\"$FORM{'make_static_capable'}\";\#must be \"yes\" to enable\n"; #NEW
	
	print OPTIONS "\$files_to_log=\"$pages_to_log\";\n\n";
	

	print OPTIONS "\$security=\"777\";\n";
	print OPTIONS "\$allow_self_modify=$allow_self_modify;\n";
	print OPTIONS "\$auto_sponsor_notify=$auto_sponsor_notify;\n";
	print OPTIONS "\$maxtime=40;\n";
	print OPTIONS "\$maxlocktime=10;\n"; #NEW
	
	print OPTIONS "\n\n\# *** AFFILIATE COMMISSION DATA *** \n\n";
	print OPTIONS "\$mlm=0;\n";
	
	##
	print OPTIONS "\$comm_type\[1\]=\"formula\";\n";
	print OPTIONS "\$formula\[1\]=\"PRICE * 0\";\n";
	print OPTIONS "1;\n";
	close(OPTIONS);
	system "chmod 777 $admindir/options.pm";
	$cginame=$ENV{'SCRIPT_FILENAME'};
	$cgidirlength=length($cginame);
	$cgibinguess = substr($cginame, 0, $cgidirlength-12); #"/install.cgi" is 12 characters

	print qq^<P>options.pm has been created in this directory: <STRONG>$admindir</STRONG>
	<P>
	<STRONG>You MUST move the options.pm file from the admin directory to the install directory ($cgibinguess) for the software to operate correctly. You will need to do this via telnet or FTP.</STRONG>
	<P>
	<FONT COLOR="#FF0000"><STRONG>IMPORTANT SECURITY NOTE: Now that the options.pm file has been created, you MUST delete the "install.cgi" file from the installation directory.
	<P>
	If you leave this file here, other people will be able to change your password just by executing this script!
	</FONT></STRONG>
	<P>
	^;
	&create_email;
	&write_password;
	print "</BODY></HTML>";
	exit;
}


sub create_email
{
	open(MAIL,"|$mailprog -t");
	print MAIL "To: $admin_name <$FORM{'admin_email'}>\n";
	print MAIL "From: $admin_name <$FORM{'admin_email'}>\n";
	print MAIL "Subject: Test Email from software installation\n";
	print MAIL "\nThis email confirms the proper location and operation of the mail program you specified during the configuration file installation  . . .\n";
	close(MAIL);
}


sub write_password
{ 
	$password_file = "$admindir/password.txt";
	$encrypt = crypt ($password, "aa");
	open(PASSFILE, ">$password_file");
	print PASSFILE "$encrypt";
	close(PASSFILE);
	if (! -e $password_file)
	{
	  print "Password file could not be created. Please check the permissions of $admindir<BR>\n";
	}
	else 
	{
	  print "Password file has been written -- don't forget your password ($password) !!";
	  system "chmod $security $password_file";
	}
}


sub output_form
{
	&guesses;
	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Software Installation -- Start</TITLE></HEAD>";
	print "<BODY BGCOLOR=\"\#FFFFFF\" TEXT=\"\#000000\" LINK=\"\#0000FF\" VLINK=\"\#000000\" ALINK=\"\#000000\">";
	print "<CENTER><B><FONT COLOR=\"FF0000\" SIZE=5>Software Installation -- Start</FONT><P>";
	print "<B>Be sure to review the \"Installation\" section in the manual before filling out and submitting this form!</CENTER>";
	print "<FORM ACTION=\"$cgiscript\" METHOD=\"POST\">";
	print "<CENTER><TABLE WIDTH=80% CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#000000\" BORDER=1><TR><TD BGCOLOR=\"ffffcc\"><B>";
	print "<CENTER><FONT SIZE=+2>SERVER PATH INFORMATION</FONT></CENTER><P>";
	print "<CENTER><TABLE CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#FF0000\" BORDER=1 width=\"90%\">";
	print "<TR><TD width=40%>Enter the base URL for your web site: <BR><INPUT TYPE=\"text\" NAME=\"baseurl\" SIZE=30 VALUE=\"http://$baseurlguess1\"><BR>(do NOT include a trailing \"/\")</TD><TD>This is usually the same as your home page, minus the last slash and filename.<P>For instance, if your web site URL is http://www.yourdomain.com/index.html your \"base URL\" would be: <B>http://www.yourdomain.com</B><P><STRONG>NOTE: You must create a \"yimages\" directory (folder) in your main web directory and upload the program images there. (See user guide for details.)</STRONG></TD></TR>\n";
	print "<TR><TD>Enter the base URL for your software install directory<BR><INPUT TYPE=\"text\" NAME=\"cgiurlguess\" SIZE=30 VALUE=\"$cgiurlguess[1]\"><BR>(do NOT include a trailing \"/\")</TD><TD>Following the examples above, this will be something like this: <B>http://www.yourdomain.com/cgi-bin/y</B></TD></TR>\n";
	
	print qq^<TR><TD>(OPTIONAL) Enter the URL for your header image<BR><INPUT TYPE=\"text\" NAME=\"header_image_url\" SIZE=30 VALUE=\"\"><BR><STRONG>(Must start with http://)</STRONG><P>Width (pixels): <input type="text" name="header_image_width" value="" size="3"><BR>Height (pixels): <input type="text" name="header_image_height" value="" size="3"></TD><TD>The image you specify here will be centered at the top of every control panel screen displayed by the software (for you AND your affiliates)</TD></TR>\n^;
	
	print "<TR><TD>Sendmail program path:<SELECT NAME=\"mailprog\"><BR>\n";
	foreach $path (@paths)
	{
		print "<OPTION>$path\n";
	}
	
	print "</SELECT><BR>OR, enter your sendmail path here:<BR><INPUT TYPE=\"text\" NAME=\"mailprog2\" SIZE=30 VALUE=\"$mailprog\">";
	print qq^</TD><TD>
	This one is important; here are a couple of ways to find out what it is:
	<OL>
		<LI> The "install.cgi" program does a "whereis" command to try and locate the sendmail path. Choose from the list you are presented in the list box.
		<LI> Look for your ISP's "FAQ" or "Customer Support" page. Sendmail path information is usually kept in a "CGI Scripts" section.
		<LI> Telnet to your web site and enter "whereis sendmail" -- one or more paths should be shown -- use the simplest . . .
		<LI> Try using the most common path: <B>/usr/sbin/sendmail</B> -- this is the right path 90% of the time
		<LI> ASK your ISP! :o)
	</OL>
	</TD></TR>\n^;
	print qq^<TR><TD colspan=2><BLOCKQUOTE>
	The software has determined the install directory to be:
	<P>
	$cgibinguess
	<P>
	This is full pathname of the directory where you uploaded the install.cgi script.
	<P>
	Within this directory you need to create the following subdirectories:
	<P>
	<strong>templates</strong><BR>
	<strong>admin</strong><BR>
	<strong>errors</strong><BR>
	<P>
	The permissions on these directories should be set to 777
	<P>
	<strong>Within the "admin" subdirectory</strong>, you need to create the following subdirectories:
	<P>
	<strong>aff_info</strong><BR>
	<strong>aff_orders</strong><BR>
	<strong>aff_points</strong><BR>
	<strong>temp</strong><BR>
	<strong>ip</strong><BR>
	<strong>cookie_IP</strong><BR>
	<strong>access_logs</strong><BR>
	<strong>lock</strong><BR>
	<P>
	The permissions on these directories should also be set to 777.
	<P>
	NOTE: With most web servers, any attempt to access a file within the CGI directory (i.e. cgi-bin)
	with your web browser results in a "403 Forbidden" error -- so your various admin files should be 
	safe from anyone's casual attempts to browse them.
	<P>
	However, you need to check this for yourself. If your server allows casual browsing of files
	within the CGI directory, you will need to password protect the "admin" directory.
	<P>
	Your hosting company can tell you how to do this (it's different for each hosting company).
	<P>
	<input type="hidden" name="tempdir" value="$cgibinguess/templates">
	<input type="hidden" name="admindir" value="$cgibinguess/admin">
	</BLOCKQUOTE>
	</TD></TR>\n^;
			
	print qq^<TR><TD>Configure for static affiliate pages? <input type="checkbox" name="make_static_capable" value="yes">
	<P>
	Affiliates Directory:<BR><INPUT TYPE=\"text\" NAME=\"assocdir\" SIZE=30 VALUE=\"$baseguess\/welcome\"><BR>(do NOT include a trailing \"/\")</TD>
	<TD>Generally this feature is not recommended because of the disk space and file requirements. However, if you want your affiliates to have one or more static HTML pages hosted on YOUR server, check this box and fill in the path value to enable this feature.
	<P>
	<STRONG>NOTE: You will need to create this directory and change its permissions to 777</STRONG>
	<P>
	The specified directory will contain a sub-directory for each one of your affiliates. You may want to name it "home", "products", "store", "welcome" or something similarly
	generic and vague. Your affiliates probably won't want this directory name to be a tip-off that it is an affiliate site -- so I would NOT recommend using something like "affiliates", "dealers",
	"referral" . . .
	<P>
	<FONT COLOR="#FF0000"><B>Note: This directory should NOT be inside the admin directory or template file directory. It should be located in the "main" web directory!<P>ALSO, you should not use this directory for anything else -- do not manually upload files or create subdirectories inside this one.</B></FONT>
	</TD></TR>\n^;
	print "<TR><TD colspan=2><B>NOTE: ALL of the above directories must be created BEFORE you click on the \"Confirm\" button at the end of this page.<P>If they do not exist, please create them now via a telnet session or with your FTP program. They must have file permissions of 777</B></TD></TR>\n";
	print "</TABLE>";
	print "</TD></TR><TD BGCOLOR=\"EECCCC\"><B>";
	
	print "<CENTER><FONT SIZE=+2>GENERAL CONFIGURATION VALUES</FONT></P></CENTER><P>";
	print "<CENTER><TABLE CELLPADDING=5 CELLSPACING=0 BORDER=1  BORDERCOLOR=\"#FF0000\" width=\"90%\">\n";
	print "<TR><TD>Enter your \"admin\" name:<INPUT TYPE=\"text\" NAME=\"admin_name\" VALUE=\"$admin_name\"></TD><TD>Same as above -- this is the name people will see their email confirmations/notifications are coming from. You can use your name or \"Support\", \"Admin\", \"MySite.com\", etc...</TD></TR>\n";
	print "<TR><TD width=40%>Enter your \"admin\" email address:<INPUT TYPE=\"text\" NAME=\"admin_email\" VALUE=\"$admin_email\"></TD><TD>When your customer's and/or affiliates receive any email notifications from this system, THIS is the email address in the \"FROM\" section of that email. <P>Typical values for this email address include support\@yourdomain.com and admin\@yourdomain.com</TD></TR>\n";
	print "<TR><TD>Choose your admin password:<INPUT TYPE=\"text\" NAME=\"password\" VALUE=\"$password\"></TD><TD>This is the password which you will need to access the various administrative functions of the affiliate program software. It will be encrypted and stored in your administration directory. <P><B>Please use letters and numbers only.</B><P>Don't forget this password once you've created it! You can always change the password from the \"Control Panel\" later.</TD></TR>\n";
	print "<TR><TD>Prefix for affiliate numbers: <INPUT TYPE=\"text\" NAME=\"anumprefix\" SIZE=10 VALUE=\"\"></TD><TD>All your affiliate numbers will have this prefix. I would NOT recommend using something like \"dealer\" or \"affiliate\" here.<P>You may use any combination of letters and/or numbers, or <B>you MAY choose to have no affiliate number prefix by leaving this field blank.</B></TD></TR>\n";
	print "<TR><TD>Suffix for affiliate numbers: <INPUT TYPE=\"text\" NAME=\"anumsuffix\" SIZE=10 VALUE=\"\"></TD><TD>Same thing as the prefix, except it comes at the end of the affiliate number.</TD></TR>\n";
	print "<TR><TD>First Affiliate number (numbers only!): <INPUT TYPE=\"text\" NAME=\"initialanum\" SIZE=10 VALUE=\"10000\"></TD><TD>Every affiliate number will have a numerical component. This component may be (but isn't required to be) preceded and/or followed by the above specified prefix and suffix.<P>The value you specify in this field will dictate the numerical component of the first affiliate number.<P>For instance, if you specify <U>\"10000\"</U> here, and you have a <U>prefix of \"a\" and a suffix of \"z\"</U>, then the first affiliate number will be <B>\"a10000z\"</B>. The next affiliate number would be <B>\"a1001z\"</B>.<P>You should always consider the first affiliate number as your \"in-house\" number -- use that number for testing, or for your own in-house promotions.</TD></TR>\n";
	print "<TR><TD>Affiliates update their own contact information?<SELECT NAME=\"allow_self_modify\"><OPTION SELECTED>YES<OPTION>NO</SELECT></TD><TD>If you say YES to this, affiliates will be able to update their OWN contact information, and will be able to change their password if they want to. I strongly recommend enabling this option, as it will save you much administration time.<P>Note that you will ALWAYS have access to the password information, but with this option enabled, you wont need to take time to make changes for your affiliates, theyll be able to do it for themselves.</TD></TR>\n";
		print qq^<TR><TD>Do you want your affiliates to have traffic stats for their sites? <SELECT NAME=\"log_hits\"><OPTION value=\"Yes\" SELECTED>Yes<OPTION value=\"No\">No</SELECT></TD><TD>
		Traffic stats allow your affiliates to see how many visitors they're generating, what pages they're visiting, where they're coming from, etcetera. See the manual for details about implementing traffic stats.
		</TD></TR>^;
	print "</TABLE></CENTER>\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"mode\" VALUE=\"confirm\">\n";
	print "</TD></TR></TABLE>\n";
	print "<P><CENTER><INPUT TYPE=\"submit\" VALUE=\"Click Here to Confirm Setup Information\"></CENTER>";
	print "</FORM>";
	print "</BODY>";
	print "</HTML>";
}


sub guesses
{
	open(MAILPROG, "whereis sendmail |");
	@mailguess = <MAILPROG>;
	close(MAILPROG);
	foreach $guess (@mailguess)
	{
		@temp= split(/\s/, $guess);
		foreach $path (@temp)
		{
			push (@paths, $path);
		}
	}
	$baseguess = $ENV{'DOCUMENT_ROOT'};
	$cginame=$ENV{'SCRIPT_FILENAME'};
	$cgidirlength=length($cginame);
	$cgibinguess = substr($cginame, 0, $cgidirlength-12); #"/install.cgi" is 12 characters
	$baseurlguess1 = $ENV{'SERVER_NAME'};
	$baseurlguess2 = $ENV{'HTTP_HOST'};
	$cgiurlguess1=$ENV{'SCRIPT_NAME'};
	$cgiurlguess2=$ENV{'REQUEST_URI'};
	$cgiurlguess1length=length($cgiurlguess1);
	$cgiurlguess2length=length($cgiurlguess2);
	$cgiurlend1 = substr($cgiurlguess1, 0, $cgiurlguess1length-12);
	$cgiurlend2 = substr($cgiurlguess2, 0, $cgiurlguess2length-12);
	$cgiurlguess[1] = "http://$baseurlguess1$cgiurlend1";
	$cgiurlguess[2] = "http://$baseurlguess1$cgiurlend2";
	$cgiurlguess[3] = "http://$baseurlguess2$cgiurlend1";
	$cgiurlguess[4] = "http://$baseurlguess2$cgiurlend2";
}


__DATA__
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

$OVERRIDE{'cardnumber'} = "EXCLUDE";

sub make_link_button
{
	my ($name,$linkto) = @_;
	
	print "<form method=\"POST\" action=\"$linkto\">";
	print "<input type=\"submit\" value=\"$name\" name=\"B1\">";
	print "</form>";
}


sub start_url
{
	print "Content-type: text/html\n\n";
	print "<HTML>\n";
	print "<HEAD><TITLE>Information . . .</TITLE></HEAD>\n";
	print "<BODY BGCOLOR=\"\#FFFFFF\" TEXT=\"\#000000\" LINK=\"\#0000FF\" VLINK=\"\#000000\" ALINK=\"\#000000\">\n";
	if($header_image_url ne "")
	{
		my $image_string = qq^<CENTER>\n<IMG SRC="$header_image_url"^;
		if ($header_image_width > 0 && $header_image_height > 0)
		{
			$image_string .= qq^ width="$header_image_width" height="$header_image_height"^;
		}
		$image_string .= qq^></CENTER>\n<P>\n^;
		print $image_string;
	}
	print "<BLOCKQUOTE><B>\n";
}

