#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

unshift (@INC, ".");
require (options);

open (STDERR, ">errors/report.errors");
system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";


&initialize;
&get_input;

if ($report eq "getaffiliateinfo") { &getaffiliateinfo;}
elsif ($report eq "affiliatehistory") 
{
  &check_password;
  &set_bins;
  &load_bins;
  &display_affiliate_history;
}
else
{
  &check_password; 
  &buildhashes;
  &write_filepass;
  &printreport;
}
exit;


sub set_bins
{
  $tempyear = $startyear;
  $tempmonth = $start_month_num;
  $tempday = $startday;
  while(! $binscreated)
  {
    if ($tempmonth == 1) 
    { 
      &determine_leapyear; 
      $numdays = $daysinmonth[$tempmonth] + $leapyear; 
    }
    else { $numdays = $daysinmonth[$tempmonth]; }
    if ($rangemode eq "days")
    { 
      $converted = $tempmonth + 1; #Avoid showing "0" for January, "11" for December
      if (length($converted) < 2) {$converted = "0" . $converted;}
      if (length($tempday) < 2) { $tempday = "0" . $tempday;}
      $binlabel = "$converted/$tempday/$tempyear";
      
      # set new values
      
      if ($tempyear == $endyear && $tempmonth == $end_month_num && $tempday == $endday) { $binscreated = 1; }
      else
      {
      	$tempday++;
      	if ($tempday > $numdays)
      	{
      	  $tempday = 1;
      	  $tempmonth++;
      	  if ($tempmonth > 11)
      	  {
      	    $tempmonth = 0;
      	    $tempyear++;
      	  }
      	}
      }
    }
    elsif ($rangemode eq "weeks")
    {
      $endweek_year = $tempyear;
      $endweek_month = $tempmonth;
      $endweek_day = $tempday + 6;
      if ($endweek_day <= $numdays) {1;} # all seven days within same month
      else #go into the next month
      {
      	$endweek_month = $tempmonth + 1;
      	if ($endweek_month > 11) #went into next year
      	{
      	  $endweek_month = 0; 
      	  $endweek_year = $tempyear + 1;
      	}
      	if (length($endweek_month) < 2) {$endweek_month = "0" . $endweek_month;}
      	$endweek_day = 7 - ($numdays - $tempday + 1);
      }
      $converted = $tempmonth + 1;
      if (length($converted) < 2) {$converted = "0" . $converted;}
      $converted2 = $endweek_month + 1;
      if (length($converted2) < 2) {$converted2 = "0" . $converted2;}
      if (length($tempday) < 2) { $tempday = "0" . $tempday;}
      if (length($endweek_day) < 2) { $endweek_day = "0" . $endweek_day;}
      $binlabel = "$converted/$tempday/$tempyear - $converted2/$endweek_day/$endweek_year";
      
      # set new values
      if ( ($endweek_year > $endyear) || ($endweek_year == $endyear && $endweek_month > $end_month_num) || ( $endweek_year == $endyear && $endweek_month == $end_month_num && $endweek_day >= $endday)) 
      { 
      	if ($endweek_year > $endyear) #week crossed over to next year
      	{
      	  $endyear = $endweek_year; 
      	  $end_month_num = 0;
      	  $endday = $endweek_day;
      	}
      	elsif ($endweek_year == $endyear && $endweek_month > $end_month_num) #crossed over to next month
      	{
      	  $end_month_num = $endweek_month;
      	  $endmonth = $months[$end_month_num];
      	  $endday = $endweek_day;
      	}
      	else # $endweek_year == $endyear && $endweek_month == $end_month_num && $endweek_day >= $endday
      	{
      	  $endday = $endweek_day;
      	}
      	$binscreated = 1;
      }
      else
      {
      	$tempyear = $endweek_year;
      	$tempmonth = $endweek_month;
      	$tempday = $endweek_day+1;
      }
    }
    else # $rangemode eq months
    {
      $converted = $tempmonth + 1; #Avoid showing "0" for January, "11" for December
      if (length($converted) < 2) {$converted = "0" . $converted;}
      $binlabel = "$converted/$tempyear";
      
      #set new values
      
      $tempmonth++;
      if ($tempmonth > 11)
      {
      	$tempmonth = 0;
      	$tempyear++;
      }
      if ($tempyear > $endyear || ($tempyear == $endyear && $tempmonth > $end_month_num)) {$binscreated = 1;}
    }
    push(@bins, $binlabel);
  }
  $bincount = @bins;
}


sub load_bins
{
  $dealerfilename = $log_dir . "/" . $file_prefix . "-dealers.txt";
  system "chmod 777 $dealerfilename";
  open(DEALERFILE, "<$dealerfilename");
  while(<DEALERFILE>)
  { 
    if ( ($_ !~ /\-UPDATE\-/) && ($_ !~ /\-DELETED\-/) ) { push (@dealerinfo, $_); }
  }
  close(DEALERFILE);
  system "chmod $security $dealerfilename";
  $total_elements = @dealerinfo;
  $total = 0;
#  print "Content-type: text/plain\n\n";
      	#print "Content-type: text/html\n\n";

  #print "Starting for loop. Total elements = $total_elements<BR>\n\n";
  
  for ($element=0; $element<$total_elements; $element++)
  #for ($element=0; $element<20; $element++)
  {
    @fields = split (/\|/, $dealerinfo[$element]);
    ($date,$timeofday)=split (/\@/, $fields[12]); # in this format: 1999-Feb-04@09:22:44
    ($year, $mon, $day) = split(/\-/, $date);
    $mon_num = $monthhash{$mon};
    $total++;
#    print "Total = $total and date= $year-$mon-$day\n";
    if (&inrange) #Date is within specified range, so load into data bins
    {
      $mon_num++;
      if (length($mon_num) < 2) { $mon_num = "0" . $mon_num; }
      if (length($day) < 2) { $day = "0". $day; }
#      print "In range! (total = $total)\n";
      if ($rangemode eq "days")
      {
      	$key = "$mon_num/$day/$year";
      	$hashelement{$key} += 1; #print "hashelement{$key} = $hashelement{$key}\n";
      	$totalhash{$key} = $total;
      }
      elsif ($rangemode eq "weeks")
      {
      	$match = 0;
   	$count = 0;
        while( (! $match) && ($count < $bincount) )
        {
          #print "Trying to match $mon_num,$day, $year<BR>\n";
          $candidate = $bins[$count]; #print "Candidate = $candidate<BR>";
          $candidate =~ s/ //g; #print "Candidate = $candidate<BR>\n";
          ($first, $second) = split(/\-/, $candidate);
          ($mon1,$day1,$year1) = split (/\//, $first);
          ($mon2,$day2,$year2) = split (/\//, $second);
          #print "First = $mon1,$day1,$year1<BR>Second = $mon2,$day2,$year2<BR>";
          if (&inrange2)
          {
            $key = $bins[$count];
            $hashelement{$key} += 1;
      	    $totalhash{$key} = $total;
            $match = 1;
            #print "Line=$dealerinfo[$element]<BR>\n";
            #print "Line $element Match for $key - total is $totalhash{$key}<BR>\n";
          }
          else { $count++; }
          #print "<P>\n";
        }
      }
      else #rangemode eq "months"
      {
   	$key = "$mon_num/$year";
      	$hashelement{$key} += 1;
      	$totalhash{$key} = $total;
      }
    }
    else 
    { 
    	if ( ($year < $startyear ) ||
           ( $year == $startyear  && $mon_num < $start_month_num) ||
           ( $year == $startyear  && $mon_num == $start_month_num && $day < $startday) )
    	
    	{ $previous_total++; } # keep track of the number of affiliates added but not in date range
    }
  }
}


sub determine_leapyear
{
  $mod4 = $tempyear % 4; 
  $mod100 = $tempyear % 100;
  $mod400 = $tempyear % 400;
  if ($mod4 == 0)
  {
    if ($mod100 == 0)
    {
      if ($mod400 == 0) {$leapyear = 1;}
      else {$leapyear = 0;}
    }
    else { $leapyear = 1; }
  }
  else { $leapyear = 0; }
}


sub inrange
{
  if (($year < $startyear || $year > $endyear) ||
     ( $year == $startyear  && $mon_num < $start_month_num) ||
     ( $year == $endyear  && $mon_num > $end_month_num) ||
     ( $year == $startyear  && $mon_num == $start_month_num && $day < $startday) ||
     ( $year == $endyear && $mon_num == $end_month_num && $day > $endday ) )
     { return 0;}
     else { return 1;}
}


sub inrange2
{
  #normal situation, where mon1<=mon2, day1<=day2, year1<=year2
  if ( ($mon_num >= $mon1) && ($mon_num <= $mon2) && ($day >= $day1) && ($day <= $day2) && ($year >= $year1) && ($year <= $year2) ) {return 1;}

  #situation where week wrapped to new month, causing mon1 < mon2 and day1 > day2
  if ( $mon1 < $mon2 && $day1 > $day2 && $year1 == $year2)
  {
    if (($day >= $day1 && $mon_num == $mon1 && $year==$year1) || ($day <= $day2 && $mon_num == $mon2 && $year==$year1)) { return 1; }
  }

  #situation where week wrapped to new month and year, causing mon1 > mon2 and day1 > day2
  if ( $mon1 > $mon2)
  {
    if (($day >= $day1 && $mon_num == $mon1 && $year == $year1) || ($day <= $day2 && $mon_num == $mon2 && $year == $year2)) { return 1; }
  }
  return 0;
}

sub display_affiliate_history
{
  $maxlength = 250;
  foreach $bin(@bins)
  {
    if ($highest < $hashelement{$bin}) { $highest = $hashelement{$bin};}
  }
  
  &start_url;
  print "</BLOCKQUOTE><CENTER><FONT SIZE=4 COLOR=\"\#FF0000\">Affiliate Acquisition<BR>$startmonth $startday, $startyear - $endmonth $endday, $endyear</FONT></CENTER><HR>\n";
  if ($totalhash{$bins[0]} eq "") { $totalhash{$bins[0]} = $previous_total;}
  if ($totalhash{$bins[0]} eq "") { $totalhash{$bins[0]} = 0;}
  print "<CENTER><TABLE><TR><TD ALIGN=\"center\">Date</TD><TD ALIGN=\"center\">Affiliates Acquired</TD><TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD><TD ALIGN=\"center\">Total to Date</TD></TR>\n";
  foreach $bin (@bins)
  {
  	#print "Bin=$bin = $totalhash{$bin}<BR>\n";
  	#next;
    if ($hashelement{$bin} eq "") { $hashelement{$bin} = 0; }
    if ($totalhash{$bin} eq "") { $totalhash{$bin} = $totalhash{$previous}; }
    $barsize = int($hashelement{$bin} * ($maxlength / $highest));
    $totalbarsize = int($totalhash{$bin} * ($maxlength / $total));
  
    if ($barsize == 0) {$barsize = 1;}
    if ($totalbarsize == 0) {$totalbarsize = 1;}
    print "<TR><TD>$bin</TD><TD><IMG SRC=\"$images_url\/red.gif\" height=10 width=$barsize> $hashelement{$bin}</TD><TD></TD><TD><IMG SRC=\"$images_url\/red.gif\" height=10 width=$totalbarsize> $totalhash{$bin}</TD></TR>\n";
    $previous = $bin;
  }
  print "</TABLE></CENTER></BODY></HTML>\n";
}


sub printreport
{ 
	&start_url;
	$count=0;
	$totalit = 0;
	if ($report eq "mostsales")
	{ 
		print "<CENTER>Ranking by Number of Sales<BR>";
		print "Date Range = $startmonth $startday, $startyear to $endmonth $endday, $endyear</CENTER><HR>\n";
		#print "<PRE>";
		@sorted = sort { $assoc_sales{$a} <=> $assoc_sales{$b} } keys(%assoc_sales);
		@reversed = reverse(@sorted);
		print "<CENTER>\n<TABLE border=1 CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#000000\">";
		
		foreach (@reversed) 
		{ 
			$count++;
			$totalit += $assoc_sales{$_};
			print qq^
				<TR>
				<TD align="right"><A HREF=\"$cgi_script\?filepass=$filepass\&report=getaffiliateinfo\&dealernum=$_\" target="_blank">$count</A></TD>
				<TD align="right">$_</TD>
				<TD align="right">$assoc_name{$_}</TD>
				<TD align="right">$assoc_sales{$_}</TD>
				</TR>^;
		}
		print "</TABLE></CENTER>\n";
		print "\n<B><CENTER><FONT SIZE=5 COLOR=\"#663399\"> TOTAL: $totalit</FONT>\n</CENTER></B>";
		#print "</PRE>";
	}
	elsif ($report eq "mostsalesvolume")
	{ 
		print "<CENTER>Ranking by Sales Volume<BR>";
		print "Date Range = $startmonth $startday, $startyear to $endmonth $endday, $endyear</CENTER><HR>\n";
		@sorted = sort { $assoc_salesvolume{$a} <=> $assoc_salesvolume{$b} } keys(%assoc_salesvolume);
		@reversed = reverse(@sorted);
		print "<CENTER>\n<TABLE border=1 CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#000000\">";
		foreach (@reversed) 
		{	
			$count++;
			$totalit += $assoc_salesvolume{$_};
			$assoc_salesvolume{$_} = sprintf("%10.2f", $assoc_salesvolume{$_});
			print qq^
				<TR>
				<TD align="right"><A HREF=\"$cgi_script\?filepass=$filepass\&report=getaffiliateinfo\&dealernum=$_\" target="_blank">$count</A></TD>
				<TD align="right">$_</TD>
				<TD align="right">$assoc_name{$_}</TD>
				<TD align="right">$assoc_salesvolume{$_}</TD>
				</TR>
				^;
		}
		print "</TABLE></CENTER>\n";
		$totalit = sprintf("%10.2f", $totalit);
		print "\n<B><CENTER><FONT SIZE=5 COLOR=\"#663399\"> TOTAL: $totalit</FONT>\n</CENTER></B>";
	}
	elsif ($report eq "mostaffiliates")
	{ 
		print "<CENTER>Ranking by Number of Affiliates Sponsored</CENTER><HR>";
		@sorted = sort { $assoc_numsponsored{$a} <=> $assoc_numsponsored{$b} } keys(%assoc_numsponsored);
		@reversed = reverse(@sorted);
		print "<CENTER>\n<TABLE border=1 CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#000000\">";

		foreach (@reversed) 
		{
			$count++;
			$totalit += $assoc_numsponsored{$_};
			print qq^
				<TR>
				<TD align="right"><A HREF=\"$cgi_script\?filepass=$filepass\&report=getaffiliateinfo\&dealernum=$_\" target="_blank">$count</A></TD>
				<TD align="right">$_</TD>
				<TD align="right">$assoc_name{$_}</TD>
				<TD align="right">$assoc_numsponsored{$_}</TD>
				</TR>
				^;
		}
		print "</TABLE></CENTER>\n";
		print "\n<B><CENTER><FONT SIZE=5 COLOR=\"#663399\"> TOTAL: $totalit</FONT>\n</CENTER></B>";
	}
	elsif ($report eq "mostsponsoredsalesvolume")
	{ 
		print "<CENTER>Ranking by Sales Volume of Sponsored Affiliates<BR>";
		print "Date Range = $startmonth $startday, $startyear to $endmonth $endday, $endyear</CENTER><HR>\n";
		print "<CENTER>\n<TABLE border=1 CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#000000\">";
		@sorted = sort { $assoc_sponsoredsalesvolume{$a} <=> $assoc_sponsoredsalesvolume{$b} } keys(%assoc_sponsoredsalesvolume);
		@reversed = reverse(@sorted);
		foreach (@reversed) 
		{
			$count++;
			$totalit += $assoc_sponsoredsalesvolume{$_};
			$assoc_sponsoredsalesvolume{$_} = sprintf("%10.2f", $assoc_sponsoredsalesvolume{$_});
			print qq^
				<TR>
				<TD align="right"><A HREF=\"$cgi_script\?filepass=$filepass\&report=getaffiliateinfo\&dealernum=$_\" target="_blank">$count</A></TD>
				<TD align="right">$_</TD>
				<TD align="right">$assoc_name{$_}</TD>
				<TD align="right">$assoc_sponsoredsalesvolume{$_}</TD>
				</TR>
				^;			
		}
		$totalit = sprintf("%10.2f", $totalit);
		print "</TABLE></CENTER>\n";
		print "\n<B><CENTER><FONT SIZE=5 COLOR=\"#663399\"> TOTAL: $totalit</FONT>\n</CENTER></B>";
	}
	elsif ($report eq "mostsponsoredsales")
	{ 
		print "<CENTER>Ranking by Number of Sales by Sponsored Affiliates<BR>";
		print "Date Range = $startmonth $startday, $startyear to $endmonth $endday, $endyear</CENTER><HR>\n";
		print "<CENTER>\n<TABLE border=1 CELLPADDING=5 CELLSPACING=0 BORDERCOLOR=\"\#000000\">";
		@sorted = sort { $assoc_sponsoredsales{$a} <=> $assoc_sponsoredsales{$b} } keys(%assoc_sponsoredsales);
		@reversed = reverse(@sorted);
		foreach (@reversed) 
		{ 

			$count++;
			$totalit += $assoc_sponsoredsales{$_};
			print qq^
				<TR>
				<TD align="right"><A HREF=\"$cgi_script\?filepass=$filepass\&report=getaffiliateinfo\&dealernum=$_\" target="_blank">$count</A></TD>
				<TD align="right">$_</TD>
				<TD align="right">$assoc_name{$_}</TD>
				<TD align="right">$assoc_sponsoredsales{$_}</TD>
				</TR>
				^;
		}
		print "</TABLE></CENTER>\n";
		print "\n<B><CENTER><FONT SIZE=5 COLOR=\"#663399\"> TOTAL: $totalit</FONT>\n</CENTER></B>";
	}
	else { print "Invalid report request, please try again!";}
	print "</BODY></HTML>";
}


sub buildhashes
{
	
# Scan ls-dealers.txt building 3 hashes: affiliate#/name, affiliate/sponsor 
# and affiliate/#sponsored. For each instance of an affiliate number, check 
# if the affiliate/sponsor hash element for that sponsor already has a value. 
# If so, reduce the affiliate/#sponsored value by 1 for the previous sponsor, 
# add 1 to the new sponsor's value, and replace the affiliate/sponsor hash 
# value with the new sponsor number

  $dealerfilename = $log_dir . "/" . $file_prefix . "-dealers.txt";
  system "chmod 777 $dealerfilename";
  open(DEALERFILE, "<$dealerfilename");
  @dealerinfo=<DEALERFILE>;
  close(DEALERFILE);
  system "chmod $security $dealerfilename";
  #print "Content-type: text/plain\n\n";
  foreach $infoline(@dealerinfo)
  {
    $infoline =~ s/\-UPDATE\-//g;
    $infoline =~ s/\-DELETED\-//g;
    chop $infoline if ($infoline =~ /\n$/);
    ($name, $email, $address1, $address2, $city, $state, $zipcode, $phone, $country, $aff_num_and_level, $password, $date, $remotehost, $terms, $nospam, $where, $comment, $c3,$c4,$c5, $url, $sponsor) = split(/\|/, $infoline);
    if ($sponsor ne "")
    {
      ($sponsor, $trash) = split(/\=/, $sponsor);
      #substr($sponsor,0,4);
      ($aff_num, $trash) = split(/\-/, $aff_num_and_level);
      #$aff_num =~ s/[a-zA-Z]+.*// unless $aff_num eq "test";
      $assoc_name{$aff_num} = $name; #add to number/affiliate_name hash
      $assoc_email{$aff_num} = $email;
      if ($assoc_sponsor{$aff_num} ne "")
      { 
        #print "Affiliate $aff_num already has $assoc_sponsor{$aff_num} as a sponsor\n";
        $assoc_numsponsored{$assoc_sponsor{$aff_num}} -= 1; #subtract one from number of sponsored affiliates for previous sponsor
        #print "Count for sponsorees of $assoc_sponsor{$aff_num} is now $assoc_numsponsored{$assoc_sponsor{$aff_num}}\n";
      }
      $assoc_numsponsored{$sponsor} += 1; #add one to number of sponsored affiliates for $aff_num
      #print "Count of sponsorees for $sponsor is now $assoc_numsponsored{$sponsor}.\n";
      $assoc_sponsor{$aff_num} = $sponsor; # add to affiliate/sponsor hash
      #print "Affiliate $aff_num now has $sponsor for their sponsor\n";
    }
  }
  foreach $key(keys(%assoc_name))
  {
    if ($assoc_numsponsored{$key} == 0) {delete $assoc_numsponsored{$key};}
  }
  if ($report eq "mostaffiliates") { return; }


# Scan all order files within given date range, building 4 hashes: dealer/#sales, 
# dealer/sales_volume, dealer/sponsored_sales, dealer/sponsored_sales_volume
#
# When building dealer/sales and dealer_sales_volume hashes, use affiliate/sponsor 
# hash to locate sponsor for the current affiliate, and build dealer/sponsored_sales 
# and dealer/sponsored_sales_volume hashes in parallel


  @validlist=&get_order_info;
#  &start_url;
  $count=0;
  foreach $file (@validlist)
  {
    system "chmod 750 $file";
    open(ORDERFILE, "<$file");
    @orders = <ORDERFILE>;
    close(ORDERFILE);
    system "chmod $security $file";
    foreach $order_x (@orders)
    { 
      @data = split(/\|/, $order_x);
      $date_time = $data[1];
      ($order_date, $order_time) = split(/\@/, $date_time);
      ($year,$mon,$day) = split(/-/, $order_date);      
      $mon_num = $monthhash{$mon};
      if ($year==$startyear && $mon_num==$start_month_num && $day<$startday) { 1;}
      elsif ($year == $endyear && $mon_num == $end_month_num && $day > $endday) { 1; }
      else #Date is within range, now extract data and add to hashes
      {
        &extractall;
        if ($total > 0 || $count_returns eq "YES") #Don't count "returns"?
        {
           $assoc_sales{$aff_num} += $qty;
           $assoc_salesvolume{$aff_num} += $total;
           if ($assoc_sponsor{$aff_num} ne "NONE" && $assoc_sponsor{$aff_num} ne "")
           {
             $assoc_sponsoredsales{$assoc_sponsor{$aff_num}} += $qty;
             $assoc_sponsoredsalesvolume{$assoc_sponsor{$aff_num}} += $total;
           }
        }                    
      }      
    }
  }
}


sub initialize
{
  $cgi_script = $cgi_url . "/report.cgi";
  @months=("January","February","March","April","May","June","July","August","September","October","November","December");
  @daysinmonth=(31,28,31,30,31,30,31,31,30,31,30,31);
  
  $count=0;
  for ($count=0; $count<12; $count++)
  {
    $monabr = substr($months[$count],0,3);
    $monthhash{$monabr} = $count; #$monthhash{'Jan'} eq 0 , $monthhash{'Feb'} eq 1 , etc
  }
}

sub get_input
{
	
  if ($ENV{'REQUEST_METHOD'} eq "GET")
  {
    $buffer=$ENV{'QUERY_STRING'};
  }
  else 
  {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  }

  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs) 
  {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g;
    $value =~ s/\|/ /g;
    $FORM{$name} = $value;
  }
	foreach $key (keys %FORM)
	{
		$FORM{$key} =~ tr/\&\;\`\'\\\"\|\*\?\~\<\>\^\(\)\[\]\{\}\$\n\r/                      /;
	}
  
  $password = $FORM{'password'};
  $password =~ s/ //g;
  $report = $FORM{'report'};
  if ($report eq "") {&default;}
  $aff_num = $FORM{'dealernum'};
  $aff_num =~ s/all/ALL/i;
  $aff_num =~ s/ //g;
  if ($aff_num eq "") {$aff_num = "ALL";}
  $query_year = $FORM{'year'};
  $startday = $FORM{'startday'};
  $startmonth = $FORM{'startmonth'};
  $startyear = $FORM{'startyear'};
  $endday = $FORM{'endday'};
  $endmonth = $FORM{'endmonth'};
  $endyear = $FORM{'endyear'};
  $count_returns = $FORM{'count_returns'};
  $rangemode = $FORM{'rangemode'};
  if ($report ne "getaffiliateinfo" && ( $startday eq "" || $startmonth eq "" || $startyear eq "" || $endday eq "" || $endmonth eq "" || $endyear eq "") )
  {
      &start_url;
      print "You must enter a start and end date. Please click on the \"BACK\" button on your browser and fill in the required information.";
      print "</BODY></HTML>";
      exit;
  }
  if ($startyear > $endyear)
  {
      &bad_dates;
  }
  for ($i=0; $i<12; $i++)
  {  
      if ( $months[$i] eq $startmonth ) {$start_month_num = $i; }
      if ( $months[$i] eq $endmonth ) {$end_month_num = $i; }
  }
  if ($rangemode eq "months") #full months when doing montly reporting -- no fractional month
  {
    $startday = 1;
    $endday = $daysinmonth[$end_month_num];
    if ($end_month_num == 1) #February
    {
      $tempyear = $endyear;
      &determine_leapyear;
      $endday  += $leapyear; #add day for leapyear if necessary
    }
  }
  else
  {
    $tempstart = $daysinmonth[$start_month_num];
    $tempend = $daysinmonth[$end_month_num];
    if ($start_month_num == 1)
    {
      $tempyear = $startyear;
      &determine_leapyear;
      $tempstart += $leapyear;
    }
    if ($end_month_num == 1)
    {
      $tempyear = $endyear;
      &determine_leapyear;	
      $tempend += $leapyear;
    }
    if ( $startday > $tempstart) {$startday = $tempstart;} #use correct number of days in month
    if ( $endday > $tempend) {$endday = $tempend;}
  }
  
  if (($startyear == $endyear && $start_month_num > $end_month_num) || ($startyear == $endyear && $start_month_num == $end_month_num && $startday > $endday))
  {
      &bad_dates;
  }
  if ($start_month_num < 10) {$start_month_num = "0" . $start_month_num;}
  if ($end_month_num < 10) {$end_month_num = "0" . $end_month_num;}
}


sub default
{
  &check_password;
  &start_url;
  print "<CENTER><H2>Sales Ranks and Affiliate Acquisition History</H2></CENTER><HR>";
  print "<FORM ACTION=\"$cgi_script\" METHOD=\"POST\"><INPUT TYPE=\"hidden\" NAME=\"password\" VALUE=\"$password\">";
  print "<CENTER>\n";
  print "<PRE>";
  print "Report from <SELECT NAME=\"startmonth\" SIZE=1><OPTION>January<OPTION>February<OPTION SELECTED>March<OPTION>April<OPTION>May<OPTION>June<OPTION>July<OPTION>August<OPTION>September<OPTION>October<OPTION>November<OPTION>December</SELECT><SELECT NAME=\"startday\" SIZE=1><OPTION>1<OPTION>2<OPTION>3<OPTION>4<OPTION>5<OPTION>6<OPTION>7<OPTION>8<OPTION>9<OPTION>10<OPTION>11<OPTION>12<OPTION>13<OPTION>14<OPTION>15<OPTION>16<OPTION>17<OPTION>18<OPTION>19<OPTION>20<OPTION>21<OPTION>22<OPTION>23<OPTION>24<OPTION>25<OPTION>26<OPTION>27<OPTION>28<OPTION>29<OPTION>30<OPTION>31</SELECT> of ";
  print "<SELECT NAME=\"startyear\"><OPTION>2001<OPTION>2002<OPTION>2003<OPTION>2004<OPTION>2005<OPTION>2006<OPTION>2007<OPTION>2008<OPTION>2009<OPTION>2010</SELECT> ";
  print "to <SELECT NAME=\"endmonth\" SIZE=1><OPTION> January<OPTION>February<OPTION SELECTED>March<OPTION>April<OPTION>May<OPTION>June<OPTION>July<OPTION>August<OPTION>September<OPTION>October<OPTION>November<OPTION>December</SELECT><SELECT NAME=\"endday\" SIZE=1><OPTION>1<OPTION>2<OPTION>3<OPTION>4<OPTION>5<OPTION>6<OPTION>7<OPTION>8<OPTION>9<OPTION>10<OPTION>11<OPTION>12<OPTION>13<OPTION>14<OPTION>15<OPTION>16<OPTION>17<OPTION>18<OPTION>19<OPTION>20<OPTION>21<OPTION>22<OPTION>23<OPTION>24<OPTION>25<OPTION>26<OPTION>27<OPTION>28<OPTION>29<OPTION>30<OPTION>31</SELECT> of ";
  print "<SELECT NAME=\"endyear\"><OPTION>2001<OPTION>2002<OPTION>2003<OPTION>2004<OPTION>2005<OPTION>2006<OPTION>2007<OPTION>2008<OPTION>2009<OPTION>2010</SELECT>";
  print "</PRE><P>";
  print "<TABLE>";
  print "<TR><TD ALIGN=\"center\">CHOOSE ONE:</TD></TR>";
#  print "<TR><TD><INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"mosttraffic\" CHECKED>Ranking by most traffic</TD></TR>";
  print "<TR><TD><INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"mostsalesvolume\" CHECKED>Ranking by sales volume</TD></TR>";
  print "<TR><TD><INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"mostsales\">Ranking by number of sales</TD></TR>";
#  print "<TR><TD><INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"bestconversion\">Ranking by conversion of traffic to sales</TD></TR>";
  print "<TR><TD><INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"mostaffiliates\">Ranking by number of affiliates sponsored (date range ignored)</TD></TR>";
  print "<TR><TD><INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"mostsponsoredsalesvolume\">Ranking by sales volume of sponsored affiliates</TD></TR>";
  print "<TR><TD><INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"mostsponsoredsales\">Ranking by number of sales by sponsored affiliates</TD></TR>";
  print "<TR><TD><INPUT TYPE=\"radio\" NAME=\"report\" VALUE=\"affiliatehistory\">History of Affiliate Acquisition</TD></TR>";
  print "<TR><TD align=\"center\">(Choose reporting format for history report:<INPUT TYPE=\"radio\" NAME=\"rangemode\" VALUE=\"days\"> Daily <INPUT TYPE=\"radio\" NAME=\"rangemode\" VALUE=\"weeks\"> Weekly <INPUT TYPE=\"radio\" NAME=\"rangemode\" VALUE=\"months\"> Monthly )</TD></TR>";
  print "</TABLE>";
  print "<INPUT TYPE=\"submit\" name = \"B_SUB\" VALUE=\"    GENERATE REPORT    \"><HR>";
  print "</CENTER></FORM>";
  print "</BODY>\n";
  print "</HTML>\n";
  exit;
}

sub check_password
{
  $passfile = $log_dir . "/" . "password.txt"; 
  if (-e $passfile)
  {
    system "chmod 444 $passfile";
    open(PASSFILE, "<$passfile");
    $master_password = <PASSFILE>;
    close(PASSFILE);
    system "chmod $security $passfile";
    chop $master_password if ($master_password =~ /\n$/);
    $try = crypt ($password, "aa");
    if ($master_password eq $try)
    {
      return;
    }
  }
  &start_url;
  print "Sorry, \"$password\" does not match the recorded master password (admin password) -- please try again."; 
  print "</BODY></HTML>";
  exit;
}

sub bad_dates
{
    &start_url;
    print "The start date must be BEFORE the end date. Please click on the \"BACK\" button and re-enter your start and/or end dates.";
    print "</BODY></HTML>";
    exit;
}


sub extractall
{
  $itemlist = "";
  ($first, $middle, $last) = split(/\|\;\;\|/, $order_x);
  ($dealer, $date) = split(/\|/, $first);
  ($totcom, $customer) = split(/\|\:\:\|/, $last);
  ($total, $commission) = split(/\|/, $totcom);
  ($name, $address1, $suite, $city, $state, $zip, $phone,$email,$country,$cardname,$cardnum,$exp,$nameoncard,$ip,$c1,$c2,$c3,$c4,$c5) = split(/\|/, $customer);
  ($dn, $lvl) = split(/-/, $dealer);
  ($aff_num, $trash) = split(/\!/, $dn); #Just in case extended tracking codes are being used
  #$aff_num =~ s/[a-zA-Z]+.*// unless $aff_num eq "test";
  #$aff_num = substr($dn,0,4); 
  @items = split(/\|/, $middle);
  $qty = 0;
  foreach $item (@items)
  { 
    ($product, $price, $quantity, $cost, $commission) = split(/\:\:/, $item);
    $qty += $quantity;
  }      
}

sub get_order_info
{
  my @validlist = ();
  
    $orderfiles = $log_dir . "/*.ord";
    open (ORDERFILES, "ls $orderfiles |");
    @files = <ORDERFILES>;
    close (ORDERFILES);
    @sorted = sort(@files);
    foreach $orderfile (@sorted)
    {  
         if ($orderfile =~ /\n$/) { chop $orderfile;}
         @scratch = split(/\//, $orderfile);
         $filename = pop(@scratch);
         ($pre,$year,$monord) = split(/-/, $filename);
         ($mon, $trash) = split(/\./, $monord);
         if ( ($year > $startyear && $year < $endyear) || ($year == $startyear && $mon >= $start_month_num) || ($year == $endyear && $mon <= $end_month_num) )
         { 
             if ($year == $startyear && $endyear == $startyear && $endmonth eq $startmonth)
             {
               if ($start_month_num == $mon) 
               {
                   push(@validlist, $orderfile);
               }
             }
             else
             {
               push(@validlist, $orderfile);
             }
         }
    }
    return @validlist;
}


sub write_filepass
{
  $valid_chars="abcdefghijkmnpqrstwxyzABCDEFGHIJKLMNPQRSTWXYZ23456789";
  $seed = srand ( time() ^ ($$ + ($$ << 15)) );
  $filepass = "";
  for ($i=0; $i<8; $i++)
  {
    $randomnumber = int(rand 53);
    $letter = substr($valid_chars,$randomnumber,1);
    $filepass = $filepass . $letter;
  }
  $tempname = $log_dir . "/temp2.txt";
  system "chmod 777 $tempname";
  open(TEMPFILE, ">$tempname"); 
  print TEMPFILE "$filepass\n";
  close(TEMPFILE);
}


sub getaffiliateinfo
{
  $tempname = $log_dir . "/temp2.txt";
  system "chmod 777 $tempname";
  open(TEMPFILE, "<$tempname");
  $realpass = <TEMPFILE>;
  chop $realpass if ($realpass =~ /\n$/);
  if ($realpass eq $FORM{'filepass'})
  {
    $info_file = $nfo_dir . "/" . $aff_num . ".nfo";
    if (-e $info_file )
    {
      &showdealerinfo;
    }
    else
    {
      &start_url;
      print "No information found for that affiliate!<BR>";
      print "</BODY></HTML>";
    }
    exit;
  }
  else
  { 
    close(TEMPFILE);
    system "chmod $security $tempname";
    &start_url;
    print "Temp file password does not match. Please create new temp file by regenerating the report . . .";
    print "</BODY></HTML>";
    exit;
  }
}


sub showdealerinfo
{
  &start_url;
  system "chmod 777 $info_file";
  open(DEALERFILE, "<$info_file");
  @lines=<DEALERFILE>;
  close(DEALERFILE);
  system "chmod $security $info_file";
  $dataline=$lines[2];
  if ($dataline =~ /\n$/ ) {chop $dataline;}
  ($name, $lastname,$email,$address1,$suite,$city,$state,$zip,$phone,$country,$dn,$pw,$ld,$ip,$cb1,$cb2,$c1,$c2,$c3,$c4,$c5,$dealer_url,$ul) = split (/\|/, $dataline);
  print "<PRE>";
  print "First Name:             $name\n";
  print "Last Name:             $lastname\n";
  print "Address:          $address1\n";
  print "Suite:            $suite\n";
  print "City,State,Zip:   $city\,$state $zip\n";
  print "Country:          $country\n";
  print "Phone:            <B><FONT COLOR=\"\#FF0000\">$phone </FONT></B>\n";
  print "Email:            <A HREF=\"mailto:$email\">$email</A>\n";
  print "Home URL:         <A HREF=\"$dealer_url\">$dealer_url</A>\n\n";
  print "Affiliate Number: $aff_num\n";
  print "Affiliate Level:  $lines[1]\n";
  print "Password:         $pw\n";
  print "Signup Date:      $ld\n";
  print "IP Address:       $ip\n";
  print "Checkbox1:        $cb1\n";
  print "Checkbox2:        $cb2\n";
  print "Custom1:          $c1\n";
  print "Custom2:          $c2\n";
  print "Custom3:          $c3\n";
  print "Custom4:          $c4\n";
  print "Custom5:          $c5\n";
  print "Sponsor:          $ul\n";
  print "</PRE><HR>\n";
  print "</BODY></HTML>";
}
 
