#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################

unshift (@INC, ".");
require (options);
open(STDERR, ">errors/start.errors");

system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";
if (-e "ycookies.pm") { require(ycookies); }

$script_name = $cgi_url . "/" . "start.cgi";
&get_input;

if ($odd_day_dir ne "") #ycookies has been loaded
{
	$FORM{'ul'} = &determine_affnum($FORM{'ul'});
}
elsif ($FORM{'ul'} eq "" || $FORM{'ul'} eq "AFF_NUM") {$FORM{'ul'} = $default_affnum;}

&get_date;
&create_password;
&check_duplicate;
&create_aff_num;
&cloneit;
&write_ip_file;

if ($FORM{'thanks'} ne "")
{
	#defaults to 	$success_message="$log_dir/signup_email.txt";
	# 		$regthankyou="$log_dir/signup_thankyou.html";
	my $possible_success_message="$log_dir/" . $FORM{'thanks'} . "_email.txt";
	if (-e $possible_success_message) { $success_message = $possible_success_message; }
	
	my $possible_regthankyou="$log_dir/" . $FORM{'thanks'} . "_thankyou.html";
	if (-e $possible_regthankyou) { $regthankyou = $possible_regthankyou; }
}

&send_mail;
print "Content-type: text/html\n\n";
open(DONE, "<$regthankyou");
while(<DONE>)
{
	s/AFF_NUM/$aff_num/g;
	s/AFF_FIRSTNAME/$FORM{'firstname'}/g;
	s/AFF_LASTNAME/$FORM{'lastname'}/g;
	s/AFF_NAME/$FORM{'firstname'} $FORM{'lastname'}/g;
	s/AFF_EMAIL/$FORM{'email'}/g;
	s/AFF_PHONE/$FORM{'phone'}/g;
	s/AFF_ADDRESS/$FORM{'address'}/g;
	s/AFF_SUITE/$FORM{'suite'}/g;
	s/AFF_CITY/$FORM{'city'}/g;
	s/AFF_STATE/$FORM{'state'}/g;
	s/AFF_ZIP/$FORM{'zip'}/g;
	s/AFF_COUNTRY/$FORM{'country'}/g;
	s/AFF_CUSTOM1/$FORM{'custom1'}/g;
	s/AFF_CUSTOM2/$FORM{'custom2'}/g;
	s/AFF_CUSTOM3/$FORM{'custom3'}/g;
	s/AFF_CUSTOM4/$FORM{'custom4'}/g;
	s/AFF_CUSTOM5/$FORM{'custom5'}/g;
	s/AFF_PASSWORD/$password/g;
	print;
}
exit;


sub get_input
{
  if ($ENV{'REQUEST_METHOD'} eq "GET")
  {
    $buffer=$ENV{'QUERY_STRING'};
  }
  else 
  {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  }

  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs) 
  {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g;
    $value =~ s/\|/ /g;
    $value =~ s/\n/ /g;
    $value =~ s/\r/ /g;
    $FORM{$name} = $value;
  }
  
  foreach $key (keys %FORM)
  {
  	$FORM{$key} =~ tr/\&\;\`\'\\\"\|\*\?\~\<\>\^\(\)\[\]\{\}\$\n\r/                      /;
  }
  
  if ($FORM{'level'} eq "") {$FORM{'level'} = 1;}
  if ($FORM{'email'} =~ /..*\@..*\...*/)
  {
    $valid_email = 1;
  }
  $ip_address = $ENV{'REMOTE_ADDR'};

  if ($FORM{'firstname'} eq "" && $FORM{'lastname'} eq "" && $FORM{'name'} ne "")
  {
  	($FORM{'firstname'}, $FORM{'lastname'}) = split(/\s+/, $FORM{'name'}, 2);
  }
  elsif ($FORM{'firstname'} eq "" && $FORM{'lastname'} ne "" && $FORM{'name'} ne "")
  {
  	$FORM{'firstname'} = $FORM{'name'};
  }

  if ($FORM{'required'} eq "") 
  {
    $FORM{'required'} = "firstname,lastname,email,address,city,state,zip";
  }
  @fields = split(/,/, $FORM{'required'});
  foreach $field (@fields)
  {
    ($fieldname, $errormessage) = split(/-/, $field);
    if ($FORM{$fieldname} eq "")
    {
      if ($errormessage eq "") {$errormessage = $fieldname;}
      push(@missing, $errormessage);
      $bad_input = 1;
    }
  }
  if ($bad_input)
  {
    &start_url;
    print "Sorry, but some required information was missing. Please click on your \"BACK\" button and check the following field(s):\n<P>\n";
    print "<UL>\n";
    foreach $field(@missing) 
    {
      print "<LI>$field<BR>\n";
    }
    print "</UL>\n";
    print "</BODY>\n";
    print "</HTML>\n";
    exit;
  }
  if ($valid_email != 1)
  {
    &start_url;
    print "Sorry, but \"$FORM{'email'}\" is not a valid email address.  Please click on your \"BACK\" button and enter an email address that conforms to the following format:\n<P>\n";
    print "Valid email format: one or more letters/numbers + \"@\" + one or more letters/numbers + \".\" + two or more letters<P>";
    print "Here\'s an example: yourname\@domain.com\n<P>";
    print "</BODY>\n";
    print "</HTML>\n";
    exit;
  } 
}



sub create_aff_num
{ 
  if ($FORM{'forcednum'} ne "") #Dealer number specified
  {
    $FORM{'forcednum'} =~ s/\_//g;
    
    $tentative = $clone_root . "/" . $FORM{'forcednum'};
    if (-e $tentative || ($FORM{'forcednum'} =~ /\W/)) #Specified Dealer number already in use 
                                                       # or uses non-alphanumeric characters
    {
      &start_url;
      print "<P>Sorry, but that Affiliate number is already in use or contains non-alphanumeric characters. Please enter a different choice below:";
      print "<FORM action=\"$script_name\" method=\"POST\">\n";
      print "Enter a new affiliate number here: <input type=\"text\" name=\"forcednum\" value=\"$FORM{'forcednum'}\" size=\"20\"><BR>\n";
      print "<input type=\"submit\" value=\"Submit New Affiliate Number\">\n";
      foreach $forminput (keys %FORM)
      {
         if ($forminput !~ "forcednum") {print "<input type=\"hidden\" name=\"$forminput\" value=\"$FORM{$forminput}\">\n";}
      }
      print "</FORM></BODY></HTML>";
      exit;
    }
    else 
    { 
      $aff_num = $FORM{'forcednum'};
      $clone_url =~ s/AFF_NUM/$aff_num/g;
      $newdir = $tentative;
    }
  } 
  else
  {	
    if (-e $next_aff_num)
    {
      system "chmod 444 $next_aff_num";
      open(NUMBER, "<$next_aff_num");
      $next_num = <NUMBER>;
      close(NUMBER);
      system "chmod $security $next_aff_num";
      chop($next_num) if ($next_num =~ /\n$/);
      if ($next_num < $initial_aff_number) { $next_num = $initial_aff_number; } #in case file was zeroed
    }
    else 
    { 
      $next_num = $initial_aff_number;
      #open(TEMP, ">$next_aff_num");
      #close (TEMP);
      #system "chmod $security $next_aff_num";
    }
    do
    {
      $aff_num = $aff_num_prefix . $next_num . $aff_num_suffix;
      $clone_url2 = $clone_url;
      $clone_url2 =~ s/AFF_NUM/$aff_num/g;
      $newdir = $clone_root . "/" . $aff_num;
      $next_num++;
    }while (-e $newdir); #Affiliate number doesn't already exist
    $clone_url = $clone_url2;
    system "chmod 777 $next_aff_num";
    open(NEWNUMBER, ">$next_aff_num");
    print NEWNUMBER "$next_num";
    close(NEWNUMBER);
    system "chmod $security $next_aff_num";
  }
}


sub cloneit
{  
	
   $clone_dir = $clone_root . "/" . $aff_num; 
   if (-e $clone_root && $clone_root ne "" && $make_static_capable eq "yes")
   {	
	$newfile = $clone_root . "/index.html";
	if (! -e $newfile)
   	{
		open (NEWFILE, ">$newfile");
		print NEWFILE "<HTML><HEAD><TITLE>Nothing here . . .</TITLE></HEAD><BODY>Nothing here, sorry!</BODY></HTML>";
		close(NEWFILE);
	}
	system "mkdir $clone_dir";
	system "chmod 777 $clone_dir";
   
	opendir(FILELIST, "$originals_dir");   
	@allfiles = readdir(FILELIST);
	closedir(FILELIST);
   
	@files = (); #in case we ever run this as Apache Registry code.
	foreach $possible (@allfiles)
	{
		if ($possible =~ /\.htm/ || $possible =~ /\.shtm/) 
		{ 
			$fullfilepath = $originals_dir . "/" . $possible;
			push(@files, $fullfilepath); 
		}
	}
   
	foreach $file(@files)
	{ 
		chop $file if ($file =~ /\n$/);
		@pathfields= split(/\//, $file);
		$filename = pop(@pathfields);
		open(TEMPLATE, "<$file");
		@lines=<TEMPLATE>;
		close(TEMPLATE);
		$newfile = $clone_dir . "/" . $filename;
		open(NEWFILE, ">$newfile");
		$line = join('', @lines);
		$line =~ s/AFF_NUM/$aff_num/g;
		$line =~ s/AFF_NAME/$FORM{'firstname'} $FORM{'lastname'}/g;
		$line =~ s/AFF_FIRSTNAME/$FORM{'firstname'}/g;
		$line =~ s/AFF_LASTNAME/$FORM{'lastname'}/g;
		$line =~ s/AFF_EMAIL/$FORM{'email'}/g;
		$line =~ s/AFF_URL/$FORM{'url'}/g;
		$line =~ s/AFF_PHONE/$FORM{'phone'}/g;
		$line =~ s/AFF_ADDRESS/$FORM{'address'}/g;
		$line =~ s/AFF_SUITE/$FORM{'suite'}/g;
		$line =~ s/AFF_CITY/$FORM{'city'}/g;
		$line =~ s/AFF_STATE/$FORM{'state'}/g;
		$line =~ s/AFF_ZIP/$FORM{'zip'}/g;
		$line =~ s/AFF_COUNTRY/$FORM{'country'}/g;
		$line =~ s/AFF_CUSTOM1/$FORM{'custom1'}/g;
		$line =~ s/AFF_CUSTOM2/$FORM{'custom2'}/g;
		$line =~ s/AFF_CUSTOM3/$FORM{'custom3'}/g;
		$line =~ s/AFF_CUSTOM4/$FORM{'custom4'}/g;
		$line =~ s/AFF_CUSTOM5/$FORM{'custom5'}/g;
		print NEWFILE "$line";
		close(NEWFILE);
	}
	$newfile = $clone_dir . "/index.html";
	$new2 = $clone_dir . "/index.htm";     #Was index.htm(l) copied?
	if ((! -e $newfile) && (! -e $new2))   #If not, affiliate program to use dynamic index file
	{
		$new_url = $cgi_url . "/d.cgi?index-$aff_num";
		open (NEWFILE, ">$newfile");
		print NEWFILE "<HTML><HEAD><TITLE>Going to new site . . .</TITLE><META http-equiv=\"refresh\" content=\"0; url=$new_url\"></HEAD><BODY><CENTER><FONT SIZE=4><B><A HREF=\"$new_url\">Loading . . .</A></CENTER></BODY></HTML>";
		close(NEWFILE);
		#system "cp $newfile $new2";
	}
	else
	{
		$new_url = $clone_url; #no index.html or index.htm required in URL
	}
	system "chmod $security $clone_dir/*";
	system "chmod 755 $clone_dir/*.html";
	system "chmod 755 $clone_dir/*.htm";
   }	
   
   $info_file = $nfo_dir . "/" . $aff_num . ".nfo";
   open(NEWFILE, ">$info_file");
   print NEWFILE "$FORM{'email'}\n";
   print NEWFILE "$FORM{'level'}\n";
   print NEWFILE "$FORM{'firstname'}\|$FORM{'lastname'}\|$FORM{'email'}\|$FORM{'address'}\|$FORM{'suite'}\|$FORM{'city'}\|$FORM{'state'}\|$FORM{'zip'}\|$FORM{'phone'}\|$FORM{'country'}\|$aff_num\-$FORM{'level'}\|$password\|$long_date\|$ip_address\|$FORM{'checkbox1'}\|$FORM{'checkbox2'}\|$FORM{'custom1'}\|$FORM{'custom2'}\|$FORM{'custom3'}\|$FORM{'custom4'}\|$FORM{'custom5'}\|$FORM{'url'}\|$FORM{'ul'}\n";
   print NEWFILE "$FORM{'ul'}\n";
   close(NEWFILE);
   system "chmod $security $info_file";

   $sponsor_level = &get_sponsor_level;
   if ($points{$sponsor_level} > 0)
   {
   	$point_file = $points_dir . "/" . $FORM{'ul'} . ".points";
	open(PFILE, ">>$point_file");
	print PFILE "$long_date\|$ip_address\|Sponsored: $FORM{'firstname'} $FORM{'lastname'}\|$points{$sponsor_level}\n";
	close(PFILE);
	system "chmod 777 $point_file";
   }   

   $default_index = $log_dir . "/index.html";
   if (! -e $default_index)
   {
     open (NEWFILE, ">$default_index");
     print NEWFILE "<HTML><HEAD><TITLE>Nothing here . . .</TITLE></HEAD><BODY>Nothing to see here, sorry!</BODY></HTML>";
     close (NEWFILE);
   }
   
   $logfilename = $log_dir . "/" . $file_prefix . "-dealers.txt";
   system "chmod 777 $logfilename";
   open(LOGFILE, ">>$logfilename");
   print LOGFILE "$FORM{'firstname'}\|$FORM{'lastname'}\|$FORM{'email'}\|$FORM{'address'}\|$FORM{'suite'}\|$FORM{'city'}\|$FORM{'state'}\|$FORM{'zip'}\|$FORM{'phone'}\|$FORM{'country'}\|$aff_num\-$FORM{'level'}\|$password\|$long_date\|$ip_address\|$FORM{'checkbox1'}\|$FORM{'checkbox2'}\|$FORM{'custom1'}\|$FORM{'custom2'}\|$FORM{'custom3'}\|$FORM{'custom4'}\|$FORM{'custom5'}\|$FORM{'url'}\|$FORM{'ul'}\n";
   close(LOGFILE);
   system "chmod $security $logfilename";
   system "chmod 755 $default_index";
}


sub get_date
{
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  $year += 1900;
  if ($sec < 10) 
  {
    $sec = "0$sec";
  }

  if ($min < 10) 
  {
    $min = "0$min";
  }

  if ($hour < 10) 
  {
    $hour = "0$hour";
  }

  if ($mon < 10) 
  {
    $mon = "0$mon";
  }

  if ($mday < 10) 
  {
    $mday = "0$mday";
  }

  $month=$mon+1;

  @months = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

  if ($year < 1000) {$year = 1900 + $year;} # < 4 digits
  $date = "$hour\:$min\:$sec $month/$mday/$year";
  chop($date) if ($date =~ /\n$/);
  $long_date = "$year-$months[$mon]-$mday\@$hour\:$min\:$sec";

}


sub create_password
{
  $p1 = $FORM{'forcedpass1'}; $p2 = $FORM{'forcedpass2'};
  if ($p1 || $p2)
  {
    if ($p1 ne $p2)
    {
      &start_url;
      print "<P>Your password check value did not match the password.<BR>";
      print "Please enter the desired password in both of the below boxes and click the submit button.<P>";
      print "If you prefer to have your password created for you, just leave both boxes blank and click the submit button.<P>";
      print "<FORM action=\"$script_name\" method=\"POST\">\n";
      print "Enter your password choice here: <input type=\"password\" name=\"forcedpass1\" value=\"\" size=\"20\"><BR>\n";
      print "For confirmation, enter the same value here: <input type=\"password\" name=\"forcedpass2\" value=\"\" size=\"20\"><BR>\n";
      print "<input type=\"submit\" value=\"Submit Password\">\n";
      foreach $forminput (keys %FORM)
      {
         if ($forminput !~ "forcedpass") { print "<input type=\"hidden\" name=\"$forminput\" value=\"$FORM{$forminput}\">\n"; }
      }
      print "</BODY></HTML>";
      exit;
    }
    else { $password = $p1; }
    
  }
  else
  {
    $valid_chars="abcdefghjkmnpqrstwxyzABCDEFGHJKLMNPQRSTWXYZ23456789";
    $seed = srand ( time() ^ ($$ + ($$ << 15)) );
    $password = "";
    for ($i=0; $i<8; $i++)
    {
      $randomnumber = int(rand 53);
      $letter = substr($valid_chars,$randomnumber,1);
      $password = $password . $letter;
    }
  }
  $pass_crypt = crypt($password, "aa");
}

sub send_mail 
{
  system "chmod 755 $success_message";
  open(SUCCESS, "<$success_message");
  $aff_email_message = join('', <SUCCESS>);
  close(SUCCESS);
  
  $aff_email_message =~ s/AFF_NUM/$aff_num/g;
  $aff_email_message =~ s/AFF_FIRSTNAME/$FORM{'firstname'}/g;
  $aff_email_message =~ s/AFF_LASTNAME/$FORM{'lastname'}/g;
  $aff_email_message =~ s/AFF_NAME/$FORM{'firstname'} $FORM{'lastname'}/g;
  $aff_email_message =~ s/AFF_EMAIL/$FORM{'email'}/g;
  $aff_email_message =~ s/AFF_PHONE/$FORM{'phone'}/g;
  $aff_email_message =~ s/AFF_ADDRESS/$FORM{'address'}/g;
  $aff_email_message =~ s/AFF_SUITE/$FORM{'suite'}/g;
  $aff_email_message =~ s/AFF_CITY/$FORM{'city'}/g;
  $aff_email_message =~ s/AFF_STATE/$FORM{'state'}/g;
  $aff_email_message =~ s/AFF_ZIP/$FORM{'zip'}/g;
  $aff_email_message =~ s/AFF_COUNTRY/$FORM{'country'}/g;
  $aff_email_message =~ s/AFF_CUSTOM1/$FORM{'custom1'}/g;
  $aff_email_message =~ s/AFF_CUSTOM2/$FORM{'custom2'}/g;
  $aff_email_message =~ s/AFF_CUSTOM3/$FORM{'custom3'}/g;
  $aff_email_message =~ s/AFF_CUSTOM4/$FORM{'custom4'}/g;
  $aff_email_message =~ s/AFF_CUSTOM5/$FORM{'custom5'}/g;  
  $aff_email_message =~ s/AFF_PASSWORD/$password/g;

  open(MAIL,"|$mailprog -t");
  print MAIL "To: \"$FORM{'firstname'} $FORM{'lastname'}\" <$FORM{'email'}>\n";
  print MAIL "From: \"$admin_name\" <$admin_email>\n";
  print MAIL "Subject: Affiliate Signup Confirmation\n";
  print MAIL $aff_email_message;
  close (MAIL);

  open(REMAIL,"|$mailprog -t");
  print REMAIL "To: \"$admin_name\" <$admin_email>\n";
  print REMAIL "From: \"$FORM{'firstname'} $FORM{'lastname'}\" <$FORM{'email'}>\n";
  print REMAIL "Subject: New Affiliate Sign-Up!\n\n";
  print REMAIL "$FORM{'firstname'} $FORM{'lastname'} just signed up to be a Level-$FORM{'level'} affiliate! \nTime of signup: $long_date \n Sign-up came from host $ip_address\n\n";
  print REMAIL "Here is their info:\n";
  print REMAIL "Name:           $FORM{'firstname'} $FORM{'lastname'}\n";
  print REMAIL "Address:        $FORM{'address'}\n";
  if ($FORM{'suite'} ne "")
  {
    print REMAIL "Suite:          $FORM{'suite'}\n";
  }
  print REMAIL "City,State,Zip: $FORM{'city'},$FORM{'state'} $FORM{'zip'}\n";
  if ($FORM{'country'})
  { 
    print REMAIL "Country:        $FORM{'country'}\n";
  }
  print REMAIL "Phone:          $FORM{'phone'}\n\n";
  print REMAIL "Affiliate Number is: $aff_num\n";
  if ($FORM{'ul'} ne "NONE" && $mlm==1) { print REMAIL "Affiliate Sponsor: $FORM{'ul'}\n";}
  if ($FORM{'url'} ne "NONE") { print REMAIL "Home URL: $FORM{'url'}\n\n";}
  print REMAIL "Password is: $password\n";
  print REMAIL "OTHER INFORMATION:\n\n";
  for ($i=1; $i< 101; $i++)
  {
    $customname = "custom" . $i;
    $customdesc = $customname . "_desc";
    if ($FORM{$customname} ne "")
    {
      if ($FORM{$customdesc} ne "")
      {
        print REMAIL "$FORM{$customdesc}: $FORM{$customname}\n";
      }
      else { print REMAIL "$customname: $FORM{$customname}\n"; }
    }
  }
  close (REMAIL);
  
  if ($FORM{'ul'} ne "NONE" && $mlm==1)
  {
    $filepath = $nfo_dir . "/" . $FORM{'ul'} . ".nfo";
    if (-e $filepath)
    {
      system "chmod 777 $filepath";
      open (READEMAIL, "<$filepath");
      @tempdata=<READEMAIL>;
      close(READEMAIL);
      $assoc_email = $tempdata[0];
      chop($assoc_email) if ($assoc_email =~ /\n$/);
      system "chmod $security $filepath";

      if ( $assoc_email ne "")
      {
      	open(ULMAIL, "|$mailprog -t");
      	print ULMAIL "To: $assoc_email\n";
      	print ULMAIL "From: \"$admin_name\" <$admin_email>\n";
      	print ULMAIL "Subject: New Affiliate Signup: $aff_num\n";
      	print ULMAIL qq^This is to inform you that $FORM{'firstname'} $FORM{'lastname'} has just signed up under you at your site.^;
      	#print ULMAIL "\n$FORM{'name'} just signed up as an affiliate (affiliate number $aff_num) with YOU as their sponsor!\n";
      	# print ULMAIL "\nPlease contact your new partner at this email address: $FORM{'email'} and offer your full support.";
      	#print ULMAIL "\n\nIf you have any questions or concerns, please don't hesitate to send me an email!\n\n";
      	#print ULMAIL "$admin_name\n$admin_email\n";
      	close(ULMAIL);
      }
    }
  }
}


sub check_duplicate
{
	if (! -e $ip_dir) { system "mkdir $ip_dir"; }
	$ipfile = $ip_dir . "/" . $ENV{'REMOTE_ADDR'};
	$maxdays = $maxtime / 1440; # convert minutes to days
	if (-e $ipfile && (-M $ipfile < $maxdays) ) #ipfile exists and is less than maxtime minutes old
	{
		&start_url;
		print "<B>It appears that you've already signed up. You may have accidentally clicked on the button more than once.<P>";
		print "You should receive an email in the next few minutes with your signup information. If you don\'t receive anything, please send an email to $admin_name at <A HREF=\"mailto:$admin_email\">$admin_email</A>.</B>";
		print "</BODY>\n";
		print "</HTML>\n";
		exit;
	}
}  


sub write_ip_file
{
	$ipfile = $ip_dir . "/" . $ENV{'REMOTE_ADDR'};
	open(EMPTY, ">$ipfile");
	close(EMPTY);
	opendir(IPDIR, "$ip_dir");
	@ipfiles = readdir(IPDIR);
	closedir(IPDIR);
	foreach $ipfile (@ipfiles)
	{
		$fullname = $ip_dir . "/" . $ipfile;
		if (-M $fullname > $maxdays) #modified more than maxtime minutes ago
		{
			system "rm $fullname";
		}
	}
}


sub get_sponsor_level
{
	my $info_file = $nfo_dir . "/" . $FORM{'ul'} . ".nfo";
	my @lines;
	my $dataline;
	my @fields;
	my $dn;
	my $dl = 0; #default;
	
  	system "chmod 777 $info_file";
  	open(DEALERFILE, "<$info_file");
  	@lines=<DEALERFILE>;
  	close(DEALERFILE);
  	$dataline=$lines[2];
  	@fields = split (/\|/, $dataline);
  	($dn, $dl) = split(/\-/, $fields[10], 2);
  	return $dl;
}
