#!/usr/bin/perl
################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################


# $dn\|$extended\|$month\/$this_day\/$this_year $this_time\|$ip\|$host\|$file\|$referrer

require(options);
open(STDERR, ">errors/traffic.errors");
system "chmod 777 $originals_dir";
system "chmod 777 $clone_root";
system "chmod 777 $log_dir";
system "chmod 777 $temp_dir";
system "chmod 777 $ip_dir";

$npg_test = 0;
if ($npg_test == 1) { open(STDERR, ">traffic.error"); }

@months = ("placeholder","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");


&initialize_global_vars;
$nfofile = $nfo_dir . "/" . $aff_num . ".nfo";

&check_password;
if ($passok != 1) 
{ 
	&start_url; 
	#print "Password: $password<BR>Clone_dir: $clone_dir<BR>";
	print "<BLOCKQUOTE><B>Error: Invalid Password<P>Please hit \"BACK\" and try again.</B></BLOCKQUOTE></BODY></HTML>";
	exit;
}

$relevant_log_files_ref = &determine_relevant_log_files($FORM{'rangetype'});
if ($npg_test == 1) { foreach (@$relevant_log_files_ref) { print STDERR "File = $_\n";} }
$log_lines_ref = &get_log_data($relevant_log_files_ref);
if ($npg_test == 1) { foreach (@$log_lines_ref) { print STDERR "Line = $_\n";} }
($parsed_data_ref, $ordered_month_year_ref) = &parse_data($log_lines_ref);
&output_report($parsed_data_ref, $ordered_month_year_ref);


sub initialize_global_vars
{
	&get_input;

	$aff_num_and_extended_code = $FORM{'dealernum'};
	($aff_num, $extended_code) = split(/\!/, $aff_num_and_extended_code, 2);
	$clone_dir =~ s/AFF_NUM/$aff_num/g;
	$password = $FORM{'password'};
	$report = $FORM{'report'};
	$cgi_script = "$cgi_url\/traffic.cgi";
}


sub determine_relevant_log_files
{
	my $range_type = $_[0]; #can be "today" "thismonth" "lastmonth" "range"
	my $from_month = $FORM{'frommonth'};
	my $from_day = $FORM{'fromday'};
	my $from_year = $FORM{'fromyear'};
	my $to_month = $FORM{'tomonth'};
	my $to_day = $FORM{'today'};
	my $to_year = $FORM{'toyear'};
	
	my $file;
	my $file_name;
	my @relevant_log_files;
	
	my $year_index;
	my $month_index;
	my $day_index;
	my $last_month;
	my $last_day;
	my $day;
	
	my $log_dir = $access_log_dir;
  	if ($log_dir eq "")
  	{
  		$log_dir = $log_dir . "/access_logs";
  		if (! -e $log_dir)
  		{
  			mkdir ($log_dir, 0777);
  		}
  	}
	if ($npg_test == 1) { print STDERR "log_dir is \"$log_dir\"\n";}
	&get_date; #sets up globals $month, $day, $year, $thismonth (Jan, Feb, etc.)
	$day = $mday;
	if ($range_type eq "today")
	{
		$from_year = $year;
		$from_month = $month;
		$from_day = $day;
		$to_year = $year;
		$to_month = $month;
		$to_day = $day;
	}
	elsif ($range_type eq "thismonth")
	{
		$from_year = $year;
		$from_month = $month;
		$from_day = 1;
		$to_year = $year;
		$to_month = $month;
		$to_day = 31;
	}
	elsif ($range_type eq "lastmonth")
	{
		$from_day = 1;
		$to_day = 31;
		$from_year = $year;
		$to_year = $year;
		$from_month = $month - 1 ;
		$to_month = $month - 1;
		if ($month == 1) #last month will be december of previous year
		{ 
			$from_year = $year - 1;
			$to_year = $from_year;
			$from_month = 12;
			$to_month = $from_month;
		}
	}
	
        #strip off leading zeroes for uniformity in loop below. Will be added back.
	$to_day =~ s/^0//;
	$from_day =~ s/^0//;

	#Now create array of all existing .traffic files in specified date range.
	for ($year_index=$from_year; $year_index <= $to_year; $year_index++)
	{
		if ($year_index == $from_year)
		{
			$start_month = $from_month;
		}
		else { $start_month = 1; }

		if ($year_index == $to_year)
		{
			$last_month = $to_month;
		}
		else { $last_month = 12; }
		
		
		for ($month_index=$start_month; $month_index <= $last_month; $month_index++)
		{
			if ($year_index == $from_year and $month_index == $from_month)
			{
				$start_day = $from_day;
			}
			else { $start_day = 1; }

			if ($year_index == $to_year and $month_index == $last_month)
			{
				$last_day = $to_day;
			}
			else { $last_day = 31; }
			
			for ($day_index = $start_day; $day_index <= $last_day; $day_index++)
			{
				$file_name = $log_dir . "/" . $year_index . "-";
				$file_name .= "$months[$month_index]-";
				if ($day_index < 10) {$file_name .= "0";}
				$file_name .= "$day_index\.traffic";
				if ($npg_test == 1)
				{
					print STDERR "File Name = $file_name\n";
				}
				if (-e $file_name)
				{
					push(@relevant_log_files, $file_name);
				}
			}
		}
	}
	return(\@relevant_log_files);
}


sub get_log_data
{
	my $log_files_ref = $_[0];
	my $file_name;
	my @log_lines;
	my $anum;
	my $trash;
	
	foreach $file_name (@$log_files_ref)
	{
		system "chmod 777 $file_name";
		open (THISFILE, "<$file_name");
		while(<THISFILE>)
		{
			if (/^$aff_num\|/) #log entry was for this specific affiliate's site
			{
				chomp;
				push(@log_lines, $_);
			}
		}
		close(THISFILE);
	}
	return(\@log_lines);
}


sub parse_data
{
	my $log_lines_ref = $_[0];
	my $dn,$code,$month_day_year_time,$ip,$host,$page,$referrer;
	my $count=0;
	my $month;
	my $day;
	my $year;
	my $month_day_year;
	my @ordered_month_year;
	my %in_ordered;
		
	foreach (@$log_lines_ref)
	{
		($dn,$code,$month_day_year_time,$ip,$host,$page,$referrer) = split(/\|/, $_);
		if ($code eq "") {$code = "(none)"; }
		if ($report eq "hits") #build hash of hashes of hashes
		{
			($month_day_year, $this_time) = split(/ /, $month_day_year_time, 2);
			($month, $day, $year) = split(/\//, $month_day_year);
			if ($test == 1)
			{
				$print_string = qq^Month_day_year_time = $month_year_day_time\n
				Month_day_year = $month_day_year\n
				month, day, year = $month , $day , $year\n^;
				print $print_string;
			}
			$month_year = $month . "/" . $year;
			if (! exists $in_ordered{$month_year})
			{
				push (@ordered_month_year, $month_year);
				$in_ordered{$month_year} = 1;
			}
			if ($test == 1) { print "month_year now is $month_year\n";}
			$data_hash{$month_year}->{$day}->{$code} += 1;
		}
		elsif ($report eq "details") #build array of hashes
		{
			$month_day_year_time =~ s/\// /;
			$month_day_year_time =~ s/\//, /;
			$data_array[$count]->{'code'} = $code;
			$data_array[$count]->{'date'} = $month_day_year_time;
			$data_array[$count]->{'ip'} = $ip;
			$data_array[$count]->{'host'} = $host;
			$data_array[$count]->{'page'} = $page;
			$data_array[$count]->{'referrer'} = $referrer;
			$count++;		
		}
		else # referrer page code -- build simple hash of requested_parameter vs number
		{
			$data_hash{$$report} += 1;
		}
	}
	
	if ($report eq "details") { return(\@data_array); }
	else { return(\%data_hash, \@ordered_month_year); }
}


sub output_report
{
	my $parsed_data_ref = $_[0];
	my $ordered_month_year_ref = $_[1];
	my $max_bar_size = 300;
	my $red_bar = $images_url . "/red.gif";
	my $bar_height = 5;
	my $bar_size;
	my $scale_factor;
	my $month_year;
	my $day;
	my $code;
	my @sorted;
	my @sorted_descending;
	my %monthly_hits;
	my $mnth;
	my $yr;
	my $key;
	my $hits;
	my $bgcolor0 = "\#EEEEEE";
	my $bgcolor1 = "\#FFFFCC";
	my $total_entries;
	my $been_here;
	my $print_string;
	my %used;
	my $date_string;
	my %descriptions =	(
					'hits' =>	'Chronological Listing of Visits to Your Page',
					'details' => 	'Full Traffic Log Details',
					'page' => 	'Page Requests',
					'referrer' => 	'Referrer Pages',
					'code' => 	'Ad Codes Used for Your Site'
				);
				
	if ($test == 1) { print "Parsed data ref in output_report: \n"; print Dumper($parsed_data_ref); print "\n\n";}
	&start_url;
	print "<CENTER><B><FONT SIZE=\"+1\">Traffic Stats for Affiliate $aff_num<BR>$descriptions{$report}</FONT></B><HR><P>\n";
	
	
	if ($report eq "hits")	#print bar graph of day/month vs hits
	{			# (break out by ad code if requested)
		$max_hits = &get_max_hits($parsed_data_ref); #find highest number for scaling
		if ($max_hits < 1) { $max_hits = 1; }
		$scale_factor = $max_bar_size / $max_hits;
		print "<table border=0 cellpadding=2 cellspacing=2 bgcolor=\#CCCCCC>\n";
		if ($FORM{'breakout'} eq "yes") 
		{ 
			$print_string = qq^<tr><td bgcolor="$bgcolor0" align="center">Date</td><td bgcolor="$bgcolor1" align="center">Hits</td><td align="right" bgcolor="#CCCCCC"> </td><td align="left" bgcolor="$bgcolor0">Ad Code</td></tr>\n^;
		}
		else
		{
			$print_string = qq^<tr><td bgcolor="$bgcolor0" align="center">Date</td><td bgcolor="$bgcolor1" align="center">Hits</td><td></td></tr>\n^;
		}
		print $print_string;

		foreach $month_year (@$ordered_month_year_ref) #(keys %$parsed_data_ref)
		{
			%monthly_hits = ();
			foreach $day (sort keys %{$parsed_data_ref->{$month_year}})
			{
				if ($FORM{'groupbymonth'} eq "yes") #just count hits -- we'll sort and output later
				{	
					foreach $code (keys %{$parsed_data_ref->{$month_year}->{$day}})
					{
						if ($FORM{'breakout'} eq "yes") { $key = $code; }
						else {$key = '!ALL!'; }
						
						$monthly_hits{$key} += $$parsed_data_ref{$month_year}->{$day}->{$code};
#						print STDERR "just added $$parsed_data_ref{$month_year}->{$day}->{$code} to monthly_hits{$key}\n";
					}
				}
				else
				{
					if ($FORM{'breakout'} eq "yes")
					{
						@sorted = sort (keys %{$parsed_data_ref->{$month_year}->{$day}}); #sort by ad codes
						foreach $code (@sorted)
						{
							#We're in "show daily hits with ad code breakout mode" -- output this data now
							$bar_size = int($scale_factor * $$parsed_data_ref{$month_year}->{$day}->{$code});
							($mnth, $yr) = split(/\//, $month_year);
							$date_string = "$mnth $day, $yr: ";
							if (exists $used{$date_string}) { $date_string = " "; }
							$print_string = qq^<tr><td align="center" bgcolor="$bgcolor0">$date_string</td><td bgcolor="$bgcolor1">$$parsed_data_ref{$month_year}->{$day}->{$code}</td><td align="left" bgcolor="#FFFFFF"><IMG SRC="$red_bar" HEIGHT=$bar_height WIDTH=$bar_size></td><td bgcolor="$bgcolor0">$code</td></tr>\n^;
							print $print_string;
							$used{$date_string} = 1 unless ($date_string eq " ");
						}
					}
					else #Not in "breakout" mode and not in group-by-month mode. 
					     #Count hits for all adcodes and output data
					{
						$hits = 0;
						foreach $code (keys %{$parsed_data_ref->{$month_year}->{$day}})
						{
							$hits += $$parsed_data_ref{$month_year}{$day}{$code};
						}
						
						$bar_size = int($hits * $scale_factor);
						($mnth, $yr) = split(/\//, $month_year);
						$print_string = qq^<tr><td bgcolor="$bgcolor0">$mnth $day, $yr: </td><td align="right" bgcolor="$bgcolor1">$hits</td><td align="left" bgcolor="#FFFFFF"><IMG SRC="$red_bar" HEIGHT=$bar_height WIDTH=$bar_size></td></tr>\n^;
						print $print_string;
					}
				}
			}
			
			if ($FORM{'groupbymonth'} eq "yes") #we now have a hash of codes vs. hits for the month
			{
				if ($FORM{'breakout'} ne "yes")
				{
					$hits = $monthly_hits{'!ALL!'};
					$bar_size = int($hits * $scale_factor);
					$print_string = qq^<tr><td bgcolor="$bgcolor0">$month_year:</td><td align="right" bgcolor="$bgcolor1">$hits</td><td align="left" bgcolor="#FFFFFF"><IMG SRC="$red_bar" HEIGHT=$bar_height WIDTH=$bar_size></td></tr>\n^;
					print $print_string;
				}
				else
				{
					
					#%used = ();
					@sorted = sort (keys %monthly_hits);
					foreach $code (@sorted)
					{
#						print STDERR "Code is $code\n";
						$hits = $monthly_hits{$code};
#						print STDERR "Hits{$code} is $hits\n";
						$bar_size = int($hits * $scale_factor);
						$date_string = "$month_year:";
						if (exists $used{$date_string}) { $date_string = " "; }
						$print_string = qq^<tr><td bgcolor="$bgcolor0">$date_string</td><td align="right" bgcolor="$bgcolor1">$hits</td><td align="left" bgcolor="#FFFFFF"><IMG SRC="$red_bar" HEIGHT=$bar_height WIDTH=$bar_size></td><td bgcolor="$bgcolor0">$code</td></tr>\n^;
						$used{$date_string} = 1 unless ($date_string eq " ");
						print $print_string;
					}
					
				}
			}
		}
		print "</TABLE>\n";
	}
	elsif ($report eq "details") #show table of details. Traverse data array and dump data. Easy.
	{
		print "<table border=0 cellpadding=2 cellspacing=2 bgcolor=\#CCCCCC>\n";
		if ($log_hits > 0) #always allow this detail now
		{ $print_string = qq^<tr><td align="center" bgcolor="$bgcolor0"><FONT SIZE="2">IP Address<br><FONT COLOR="#FF0000">Server Date/Time</FONT></FONT></td><td align="center" bgcolor="$bgcolor1"><FONT SIZE="2">ISP/Host</FONT></td><td align="center" bgcolor="$bgcolor0"><FONT SIZE="2">Page Requested<br><FONT COLOR="#FF0000">Ad Code</FONT></FONT></td><td align="center" bgcolor="$bgcolor1"><FONT SIZE="2">Referrer</FONT></td></tr>\n^;}
		else { $print_string = qq^<tr><td align="center" bgcolor="$bgcolor0"><FONT SIZE="2">Server Date/Time</FONT></td><td align="center" bgcolor="$bgcolor1"><FONT SIZE="2">Ad Code</FONT></td></tr>\n^;}
		print $print_string;
		$total_entries = scalar(@{$parsed_data_ref});
		for ($log_entry=0; $log_entry < $total_entries; $log_entry++)
		{
			if ($log_hits > 0) #always allow this detail now
			{ $print_string = qq^<tr><td align="center" bgcolor="$bgcolor0"><FONT SIZE="2">$$parsed_data_ref[$log_entry]->{'ip'}<br><FONT COLOR="#FF0000">$$parsed_data_ref[$log_entry]{'date'}</FONT></FONT></td><td align="center" bgcolor="$bgcolor1"><FONT SIZE="2">$$parsed_data_ref[$log_entry]{'host'}</FONT></td><td align="center" bgcolor="$bgcolor0"><FONT SIZE="2">$$parsed_data_ref[$log_entry]{'page'}<br><FONT COLOR="#FF0000">$$parsed_data_ref[$log_entry]{'code'}</FONT></FONT></td><td align="center" bgcolor="$bgcolor1"><FONT SIZE="2">$$parsed_data_ref[$log_entry]{'referrer'}</FONT></td></tr>\n^;}
			else { $print_string = qq^<tr><td align="center" bgcolor="$bgcolor0"><FONT SIZE="2">$$parsed_data_ref[$log_entry]{'date'}</FONT></td><td align="center" bgcolor="$bgcolor1"><FONT SIZE="2">$$parsed_data_ref[$log_entry]{'code'}</FONT></td></tr>\n^;}
			print $print_string;
		}
		print "</TABLE>";
	}
	else #referrer page code -- print bar graph of hits vs parameter. Sort keys of data_hash and dump.
	{
		print "<table border=0 cellpadding=2 cellspacing=2 bgcolor=\#CCCCCC>\n";
		$print_string = qq^<tr><td align="center" bgcolor="$bgcolor0"><FONT SIZE="2">Hits</FONT></td><td align="center" bgcolor="#CCCCCC"> </td><td align="center" bgcolor="$bgcolor1"><FONT SIZE="2">$report</FONT></td></tr>\n^;
		print $print_string;
		@sorted_descending = sort {$$parsed_data_ref{$b} <=> $$parsed_data_ref{$a}} (keys %$parsed_data_ref);
		foreach (@sorted_descending)
		{
			$been_here++;
			if ($been_here == 1) #first time in loop -- calculate scaling factor
			{
				$scale_factor = $max_bar_size / $$parsed_data_ref{$_};
			}
			$bar_size = int($$parsed_data_ref{$_} * $scale_factor);
			$print_string = qq^<tr><td align="center" bgcolor="$bgcolor0"><FONT SIZE="2">$$parsed_data_ref{$_}</FONT></td><td align="left" bgcolor="#FFFFFF"><IMG SRC="$red_bar" HEIGHT=$bar_height WIDTH=$bar_size></td><td align="center" bgcolor="$bgcolor1"><FONT SIZE="2">$_</FONT></td></tr>\n^;
			print $print_string;
		}
		print "</TABLE>";
	}
	print "</BODY></HTML>";
}


sub get_max_hits #this routine ONLY called when "hits" has been selected as report to show
{
	my $data_hash = $_[0];
	my $month_year;
	my $day;
	my $code;
	my $highest_code = 0;
	my $highest_day = 0;
	my $highest_month = 0;
	my $this_month;
	my $this_day;
	my %this_month_code;
	my @sorted_this_month_code;
	
	foreach $month_year (keys %$data_hash)
	{
		$this_month = 0;
		%this_month_code = ();
		foreach $day (keys %{$data_hash{$month_year}})
		{
			$this_day = 0;
			foreach $code (keys %{$data_hash{$month_year}{$day}})
			{
				if ($$data_hash{$month_year}->{$day}->{$code} > $highest_code)
				{
					$highest_code = $$data_hash{$month_year}->{$day}->{$code};
				}
				$this_day += $$data_hash{$month_year}->{$day}->{$code};
				$this_month += $$data_hash{$month_year}->{$day}->{$code};
				$this_month_code{$code} += $$data_hash{$month_year}->{$day}->{$code};
#				print STDERR "this_month_code{$code} = $this_month_code{$code}\n";
			}
			if ($this_day > $highest_day)
			{
				$highest_day = $this_day;
			}
		}
		if ($this_month > $highest_month)
		{
			$highest_month = $this_month;
		}
		@sorted_this_month_code = sort { $this_month_code{$b} <=> $this_month_code{$a} } (keys %this_month_code);
#		print STDERR "sorted_this_month_code[0] = $sorted_this_month_code[0]\n";
#		print STDERR "highest_code_for_month is $this_month_code{$sorted_this_month_code[0]}\n";
		if ($this_month_code{$sorted_this_month_code[0]} > $highest_code_for_month) { $highest_code_for_month = $this_month_code{$sorted_this_month_code[0]}; }
	}
		
	if ( $FORM{'breakout'} eq "yes" and $FORM{'groupbymonth'} ne "yes") { $highest = $highest_code;}
	elsif ( $FORM{'breakout'} eq "yes" and $FORM{'groupbymonth'} eq "yes") { $highest = $highest_code_for_month;}
	elsif ($FORM{'groupbymonth'} eq "yes") { $highest = $highest_month;}
	else { $highest = $highest_day; } #NO breakout and NO groupbymonth	
	return($highest);
}


sub get_date
{
	#creates a whole slew of global date variables:
	# examples: 
	# date = "09:23:12 01/12/1999"
	# long_date = "1999-Jan-12@09:23:12"
	# thismonth = "Jan"
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    	$sec = "0$sec" if ($sec < 10);
    	$min = "0$min" if ($min < 10);
	$hour = "0$hour" if ($hour < 10);
	$mday = "0$mday" if ($mday < 10);
	$month=$mon+1;
	$month = "0$month" if ($month < 10);
	my @months = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	$year += 1900;
  	$yyyymmdd = "$year$month$mday";
	$date = "$hour\:$min\:$sec $month/$mday/$year";
  	chop($date) if ($date =~ /\n$/);
  	$long_date = "$year-$months[$mon]-$mday\@$hour\:$min\:$sec";
  	$thismonth = $months[$mon];
}

sub check_password
{
  system "chmod 777 $nfofile";
  open (PASS, "<$nfofile");
  @nfolines = <PASS>;
  close(PASS);
  @nfofields = split(/\|/, $nfolines[2]);
  system "chmod $security $nfofile";
  $passwd = $nfofields[11];
  if ($password eq $passwd)
  {
    $passok = 1;
  }
  else
  {
    $passfile = $log_dir . "/" . "password.txt"; 
    if (-e $passfile)
    {
      system "chmod 444 $passfile";
      open(PASSFILE, "<$passfile");
      $master_password = <PASSFILE>;
      close(PASSFILE);
      system "chmod $security $passfile";
      chop $master_password if ($master_password =~ /\n$/);
      $try = crypt ($password, "aa");
      if ($master_password eq $try) { $passok = 1; }
    }
  }
}


sub get_input
{
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) 
	{
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/<!--(.|\n)*-->//g;
		$value =~ s/\|/ /g;
		$FORM{$name} = $value;
	}
	foreach $key (keys %FORM)
	{
		$FORM{$key} =~ tr/\&\;\`\'\\\"\|\*\?\~\<\>\^\(\)\[\]\{\}\$\n\r/                      /;
	}
}
