################################################################################
#
# This Perl program code COPYRIGHT 2005 Paul Galloway. All Rights Reserved.
# Program may not be sold or distributed except by express written permission
# of the author.
#
# The use of any part of this program or any code segments from it for any
# purpose, personal or commercial, is forbidden except by express written 
# permission of Paul Galloway.
#
# You may contact the author at the following email address:
#
# Email: paulg@paulgalloway.com
#
##############################################################################


use CGI qw/:standard :netscape/;

$odd_day_dir = $iptrack_dir . "/1";
$even_day_dir = $iptrack_dir . "/0";

$cookie_expiration = '+1y'; #can use +5y (5 years), +1m (one month), +85d (85 days) +1h (one hour) etcetera
                             # just be sure the value, when added to current date, doesn't go 
                             # past December, 2037...
                             
$ip_address=$ENV{'REMOTE_ADDR'};
$default_affnum = $aff_num_prefix . $initial_aff_number . $aff_num_suffix;
$keepold=0; #for use only with option #1 below... set to 1 or 0 


$whowins="current_affiliate"; #see below...
$i_ok = &initialization; #initialize date/directory values

# Explanation of last 2 variables above: #
# The determines who will get credit for a sale. The possible options for $whowins are:
#
#   1. "current_affiliate" -- give sale to affiliate whose # appears in URL or hidden field NOW --
#       UNLESS that number is the "in-house" (default) number, in which case we give credit to 
#       affiliate # in cookie (if one exists).
#       Rewrite cookie to hold number of whichever affiliate gets the sale credit UNLESS $keepold=1,
#       in which case we'll keep the OLD cookie number IF it's not the in-house number  
#
#       Setting $keepold=1 will slightly alter this . . . the original affiliate will always 
#       have HIS number in the cookie. If one of his previous prospects orders from another 
#       affiliate's site, that affiliate will get the sales credit. But if the previous prospect
#       EVER orders from the "main" site (coded with the in-house (default = initial)), the 
#       affiliate who initially introduced the product to the prospect will get the credit
#
#       This method assures only one thing -- a cookied affiliate will get the sale when 
#       a previous visitor to their affiliate site returns to the "main" merchant web site.
#       (I personally think this is the most fair way -- in the real world, the sales person
#        that EVENTUALLY persuades someone to BUY -- NOT the sales person who first introduced 
#       the product to the prospect -- is the salesperson that gets the credit.)
#
#   2. "cookie_affiliate" -- give sale to affiliate whose # appears in an existing cookie
#       giving no regard to whether or not that number is the "in-house" (default) affiliate number
#       Refresh existing cookie.
#
#       This is the "whoever gets to the customer first gets them forever" mode -- great for
#       early affiliates (and for the company if they are advertising their own site), 
#       but not very fair for those who are aggressive but, alas, joined later.
#
#   3. "cookie_not_inhouse" -- give sale to affiliate whose # appears in existing cookie UNLESS
#       that affiliate number is the "in-house" number (the "initial" number) in which case
#       credit is given to the affiliate whose # appears in URL (or default number as last resort)
#       Rewrite cookie with whichever affiliate gets the sale credit 
#       Like #2 except that a cookie containing the "company" affiliate number is ignored


####################################################################
##  ##  ####################################################  ##  ##
##  ##  ####!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!####  ##  ##
##  ##  ####!                                          !####  ##  ##
############!  DO NOT CHANGE ANYTHING BELOW THIS LINE  !############    
############!  ALL CONFIGURATION VARIABLES ARE ABOVE!  !############
##  ##  ####!                                          !####  ##  ##
##  ##  ####!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!####  ##  ##
##  ##  ####################################################  ##  ##  
####################################################################


sub initialization
{   
   #make sure directories are setup
   if (! -e $iptrack_dir){ mkdir ($iptrack_dir, 0777); }
   if (! -e $even_day_dir){ mkdir ($even_day_dir, 0777); }
   if (! -e $odd_day_dir){ mkdir ($odd_day_dir, 0777); }   

   ($csec,$cmin,$chour,$cmday,$cmon,$cyear,$cwday,$cyday,$cisdst) = localtime(time);
   $odd_even = $cmday % 2;
   if ($odd_even == 0) { $del_suf = 1;} else {$del_suf = 0;}
}


sub determine_affnum # pass it the "URL specified" affiliate number (including extended code)
                     # This routine will return affiliate number!extendedcode to use
{
	my $cookienum;
	my $sub_num;
	my $preaffnum;
	my $URLaffnum;
	my $extended;
	my $oldaffnum;
	my $method;
	
	$preaffnum = $_[0];
	$preaffnum =~ s/\%(25)*21/\!/;
	$preaffnum =~ s/AFF_NUM/$default_affnum/g;
	$preaffnum =~ s/\///g; # make sure ending "/" is not included in affiliate number
	
	($URLaffnum, $extended) = split(/\!/, $preaffnum, 2);
	
	if ($URLaffnum eq "AFF_NUM" || $URLaffnum eq "" || $URLaffnum =~ /none/i) {$URLaffnum = $default_affnum;}
	
	# get previously recorded affnum
	$oldaffnum = cookie('affnum');
	if ($oldaffnum eq "") # no affiliate cookie found
	{
		$oldaffnum = &check_iptrack; #check expiring IP filenames in iptrack directory
		if ($oldaffnum eq "") #no match in IP directory
		{
			$oldaffnum=$default_affnum;
			$method="assigned default";
		}
		else { $method="Found in iptrack"; }
	}
	else { $method="Found in Cookie"; }
	
	$oldaffnum =~ s/\%(25)*21/\!/;
	
	# Now we have URL specified affnum and previously stored affnum ($URLaffnum and 
	# $oldaffnum) -- which do we use? Also, which do we record in new cookie/ipfile?
	# 
	# We also have $preaffnum, the value originally passed to this routine, which is 
	# the combination of $URLaffnum and any "extended code", with a "!" separating the two
	
	if ($whowins eq "current_affiliate")
	{
		if ($URLaffnum eq $default_affnum && $oldaffnum ne $default_affnum) { $cookienum = $oldaffnum; }
		else {	$cookienum = $preaffnum; } 
		# new and old are default OR new is not default -- either way preserve most recent ad code
	}
	elsif ($whowins eq "cookie_affiliate")
	{
		if ($method eq "assigned default") { $cookienum = $preaffnum; }
		# cookie and/or IP file didn't exist, so the URL affnum!extendedcode
		
		else { $cookienum = $oldaffnum;} 
		# rewrite existing cookie, pass on previous affiliate number
	}
	else # ($whowins eq "cookie_not_inhouse")
	{
		if ($method eq "assigned default" || $cookienum eq $default_affnum || $cookienum =~ /^$default_affnum\!/) 
		{ 
			$cookienum = $preaffnum;
			# cookie and/or IP file didn't exist or were for inhouse account
			# write cookie for URL specified affnum, pass on the affnum!extendedcode
		} 
		else 	
		{
			$cookienum = $oldaffnum; 
			# cookie did exist, and was NOT the inhouse affiliate number
			# So, rewrite existing cookie, pass on previous affiliate num
		}
		 
	}		
	return($cookienum);   
}


sub check_iptrack
{   
	my $ipfile;
	my @ipfiles;  
	my $del_dir = $iptrack_dir . "\/$del_suf";
	my $fullname;
	my $iptrackfile;
	my $oldaffnum;
  
	#delete all files in yesterday's directory . . .
	opendir(IPDIR, "$del_dir");
	@ipfiles = readdir(IPDIR);
	closedir(IPDIR);
	foreach $ipfile (@ipfiles)
	{
		$fullname = $del_dir . "/" . $ipfile;
		unlink $fullname unless ($ipfile =~ /^\./);
	}
  
  
	#if IP address exists in today's tracking directory, read affnum from it.
	$iptrackfile = $iptrack_dir . "/$odd_even/" . $ENV{'REMOTE_ADDR'};
	if (-e $iptrackfile) # Still exists, even after deleting all expired files
	{
		open (AFFNUM, "<$iptrackfile");
		$oldaffnum = <AFFNUM>;
		close(AFFNUM);
	}  
	return($oldaffnum);
}


sub write_iptrack
{
  my $cookievalue = $_[0];
  my $iptrackfile = $iptrack_dir . "/$odd_even/" . $ENV{'REMOTE_ADDR'};
  open(EMPTY, ">$iptrackfile");
  print EMPTY "$cookievalue";
  close(EMPTY);
  chmod (0777, $iptrackfile);
}


sub create_cookie_string
{  
   my $cookievalue = $_[0];
   $cookie1 = cookie(-name=>'affnum', -value=>$cookievalue, -path=>'/', -EXPIRES=>$cookie_expiration);
}


sub send_cookie_before_html
{
   if ($cookie1 ne "") {print header(-type=>'text/html', -cookie=>[$cookie1], -expires=>'now');}
}


sub send_cookie_before_image
{
   if ($cookie1 ne "") {print header(-type=>'image/gif', -cookie=>[$cookie1], -expires=>'now');}
}

1;
